#!/usr/bin/perl
##############################################################################
# cw.cgi                                                                     #
# [MV]DarkViper's CW Script (created: 9.05.2000)                             #
#                                                                            #
# [MV]DarkViper                                                              #
# eMail   : webmaster@mvclan.de                                              #
# Homepage: www.mvclan.de                                                    #
# __________________________________________________________________________ #
# Copyright (C) by [MV]DarkViper (Thomas Pajor), 2000                        #
# Alle Rechte vorbehalten.                                                   #
#                                                                            #
#                                                                            #
# Lest euch die readme.htm bitte als erstes durch. Dort wird auch be-        #
# schrieben, wie das Skript installiert wird. Was die einzelnen Einstellung- #
# en bedeuten, wird bei der jeweiligen Einstellung selbst beschrieben!       #
#                                                                            #
##############################################################################

##############################################################################
#
# Hauptprogramm
#
##############################################################################

########################################### EINGEBUNDENE LIBRARIES ###########
use vars qw($req);
use CGI  qw(:cgi);
use POSIX;
$req = new CGI;
##############################################################################
#print "Content-type: text/html\n\n";

require "cw.cfg"; # Einbinden der Konfigurationsdatei!

##############################################################################
# Generieren einiger fester header und sonstigen Variablen ! :)
# HTML Fuss der Seite(n)
$html_foot = <<EOF;
 <p align="center" style="font-face:Arial;font-size:8pt;">
 Clanfights Script v1.2<br>
 Copyright  2000 by <a href="mailto:webmaster\@mvclan.de">[Mv]DarkViper</a><br>
 Website: <a href="http://www.mvclan.de" target="_blank">www.mvclan.de</a>
 </p>
 </body>
 </html>
EOF

# Kopfzeile der Tabelle im Hauptbereich :)
$html_table_cw = <<EOF;
<table width="95%" border="1" cellspacing="0" cellpadding="3" bordercolor="$style_border">
 <tr bgcolor="$style_table">
   <td><i><b>Datum</b></i></td>
   <td><i><b>Clan</b></i></td>
   <td><i><b>Gegner</b></i></td>
   <td><i><b>Score</b></i></td>
   <td><i><b>Match</b></i></td>
   <td><b><i>Options</i></b></td>
 </tr>
EOF

$bar_v = "$url_cw/bar_v.gif";
$bar_h = "$url_cw/bar_h.gif";


##############################################################################
# Hauptprogramm

get_input(); # Parameter abfragen!
init(); # Skript initialisieren!
action(); # Skript ausfhren!


##############################################################################
#
# action
#
##############################################################################
sub action
{
  if ($action eq 'details') { details(); }
  elsif ($action eq 'view') { view(); }
  elsif ($action eq 'stats') { stats(); }
  elsif ($action eq 'add') { add(); }
  elsif ($action eq 'addmaps') { addmaps(); }
  elsif ($action eq 'post') { post(); }
  elsif ($action eq 'delete') { del(); }
  elsif ($action eq 'edit') { edit(); }
  elsif ($action eq 'change') { change(); }
  elsif ($action eq 'pix') { pix(); }
  elsif ($action eq 'pixup') { pixup(); }
  elsif ($action eq 'shot') { shot(); }
  elsif ($action eq 'actions') { actions(); }
  elsif ($action eq 'actionsadd') { actionsadd(); }
  elsif ($action eq 'actionspost') { actionspost(); }
  elsif ($action eq 'actionsdel') { actionsdel(); }
  elsif ($action eq 'actionsedit') { actionsedit(); }
  elsif ($action eq 'actionschange') { actionschange(); }
  elsif ($action eq 'addfeedback') { addfeedback(); }
  elsif ($action eq 'postfeedback') { postfeedback(); }
  elsif ($action eq 'delfeedback') { delfeedback(); }
  else { view(); }
}


##############################################################################
#
# action
#
##############################################################################
sub view
{
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  # Sortieren
  @CW = sort { ($b =~ /\|(\d+)/)[0] <=> ($a =~ /\|(\d+)/)[0] } @CW;
  # HTML kopf ausgeben
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
EOF
  $f_own_clan = $req->param('own_clan');
  $f_game_type = $req->param('game_type');
  $f_pages = $req->param('pages');
  unless($f_own_clan) { @a_keys = keys %hash_clans; $f_own_clan = $a_keys[0]; }
  unless($f_game_type) { $f_game_type = "$default_gametype"; }
  unless($f_pages) { $f_pages = "1"; }
  
  while (($clan, $www) = each %hash_clans) { 
   if ($f_own_clan eq $clan) { $seperator = ' selected'; } else { $seperator = ''; } 
   $ins_clans = "$ins_clans <option value=\"$clan\" $seperator>$clan</option>\n"; 
  }

  $ins_gametypes = "<option value=\"All\">Show all Types</option>";
  foreach $gametype (@array_gametypes) { 
   if ($f_game_type eq $gametype) { $seperator = ' selected'; } else { $seperator = ''; } 
   $ins_gametypes = "$ins_gametypes <option value=\"$gametype\" $seperator>$gametype</option>\n"; 
  }
  
  #### do the paging
  # generate the number of entries first ...
  $num_entries = 0;
  foreach $line (@CW) {
   $temp_gametype = (split '\|\|', $line)[14]; chomp($temp_gametype); unless($temp_gametype) { $temp_gametype = "$default_gametype"; }
   $temp_clan = (split '\|\|', $line)[5];
  if (($f_own_clan eq $temp_clan) && (($temp_gametype eq $f_game_type) || ($f_game_type eq 'All'))) {
    $num_entries++; 
  }
  }
  $num_pages = ceil($num_entries / $i_entries_per_page);
  for ($counter = 1; $counter <= $num_pages; $counter++) {
   if ($counter == $num_pages) { $temp_string = sprintf("%d-%d", ($counter - 1) * $i_entries_per_page + 1, $num_entries); }
   else { $temp_string = sprintf("%d-%d", ($counter - 1) * $i_entries_per_page + 1, $counter * $i_entries_per_page); }
   if ($counter == $f_pages) { $seperator = ' SELECTED'; } else { $seperator = ''; }
   $ins_pages = "$ins_pages <option value=\"$counter\"$seperator>Page $counter [$temp_string]</option>\n";
  }
  if ($f_pages == -1) { $seperator = ' SELECTED'; } else { $seperator = ''; }  
  $ins_pages = "$ins_pages <option value=\"-1\"$seperator>Show All</option>\n";

  #### print the selection header  
  
    print <<EOF;
    <div align="center">
    <table border=0 cellpadding=0 cellspacing=0 width=95%>
     <tr>
      <td align=left><h3>$f_own_clan &gt; $f_game_type:</h3></td>
      <td align=right><form type=POST action="$url_script" ENCTYPE="multipart/form-data">
       <table border=0 cellpadding=0 cellspacing=0><tr>
        <td><select name="own_clan">$ins_clans</select></td>
        <td><b>&nbsp;&gt;&nbsp;</b></td>
        <td><select name="game_type">$ins_gametypes</select></td>
        <td><b>&nbsp;&gt;&nbsp;</b></td>
        <td><select name="pages">$ins_pages</select></td>
        <td>&nbsp;<input type=submit value="Show"></td>
       </tr></table></form>
      </td>
     </tr>
    </table>
    </div>
EOF
    genquickstats($f_own_clan, $f_game_type);
    print <<EOF;
    <br>
    <div align="center">
    $html_table_cw
EOF
    
    # Nun fr jede Zeile in der Datenbank, in der unser Clanname mit dem $s_own_clan bereinstimmt ausgeben :)
    $counter = 1; # zhler fr die pages
    foreach $line (@CW) { chomp($line);
      # Als erstes die Zeilen aufsplitten (holy cow :)
      ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
      unless($s_gametype) { $s_gametype = "$default_gametype"; }
      # Falls jetzt $s_ownclan & $s_own_clan bereinstimmen, weitermachen :)
      if (($s_own_clan eq $f_ownclan) && (($s_gametype eq $f_game_type) || ($f_game_type eq 'All')))      
      {
       if ((($counter > ($f_pages - 1) * $i_entries_per_page) && ($counter <= $f_pages * $i_entries_per_page)) || ($f_pages == -1))
       {
        ($i_score, $i_enscore, $i_wins, $i_losses) = getscore($s_maps);
        if ($i_wins > $i_losses) { $ins_score = "<font color=\"$style_won\"><b>$i_score : $i_enscore</b></font>"; }
        elsif ($i_wins < $i_losses) { $ins_score = "<font color=\"$style_lost\"><b>$i_score : $i_enscore</b></font>"; }
        else {
         if ($i_score > $i_enscore) {  $ins_score = "<font color=\"$style_won\"><b>$i_score : $i_enscore</b></font>"; }
         elsif ($i_score < $i_enscore) { $ins_score = "<font color=\"$style_lost\"><b>$i_score : $i_enscore</b></font>"; }
         else { $ins_score = "<font color=\"$style_draw\"><b>$i_score : $i_enscore</b></font>"; }
        }
        # Einfach ne Tabellenzeile ausdrucken!
        $color = swapcolor($color);
        print <<EOF;
          <tr bgcolor="$color"><td>$style_marked_b$i_day.$i_month.$i_year$style_marked_e</td>
          <td>$style_marked_b<a href="$hash_clans{"$s_ownclan"}" target=_blank>$s_ownclan</a>$style_marked_e</td>
          <td>$style_marked_b$s_enclanshort - <a href="$s_enclanwww" target=_blank><i>$s_enclan</i></a>$style_marked_e</td>
          <td>$ins_score</td>
          <td><font color="$hash_typecolors{"$s_gametype"}">$s_type</font></td>
          <td>$style_marked_b<a href="$url_script?action=details&num=$i_num">details</a>&nbsp;&nbsp; <font size="1"><a href="$url_script?action=pix&num=$i_num">shots</a>, <a href="$url_scrip?action=edit&num=$i_num">edit</a>, <a href="$url_script?action=delete&num=$i_num">del</a></font>$style_marked_e</td></tr>
EOF
       }
       $counter++;
      }     
    }

  print "</table></div><br>\n"; # Schlussendlich noch die Tabelle schlieen
    
    ### LEGENDE
  if ($i_show_legend) {
    print <<EOF;
    <div align="center">
     <table broder=0 cellspacing=0 cellpadding=0 width=95%><tr><td align="left"><table border=0 cellpadding=0 cellspacing=0><tr>
      <td><b>Legende:</b>&nbsp;&nbsp;&nbsp;<td>
      <td bgcolor="$style_won" width=15>&nbsp;</td><td nowrap>&nbsp;= gewonnen&nbsp;&nbsp;&nbsp;</td>
      <td bgcolor="$style_lost" width=15>&nbsp;</td><td nowrap>&nbsp;= verloren&nbsp;&nbsp;&nbsp;</td>
      <td bgcolor="$style_draw" width=15>&nbsp;</td><td nowrap>&nbsp;= unentsch.&nbsp;&nbsp;&nbsp;</td>
EOF
    while (($t, $c) = each %hash_typecolors) { print "<td bgcolor=\"$c\" width=15>&nbsp;</td><td nowrap>&nbsp;= $t&nbsp;&nbsp;&nbsp;</td>\n";  }
    print <<EOF;
     </tr></table></td></tr></table>
    </div>
EOF
  }
  
 print "$html_foot";
 exit;
}


##############################################################################
#
# details: Anschauen der Details ber ein Match :)
#
##############################################################################
sub details
{
  # Parameter berprfen ;-)
  unless ($f_num) { die error(missing_param); }
  # OK, als erstes DB auslesen :)
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  @CW = sort { ($b =~ /\|(\d+)/)[0] <=> ($a =~ /\|(\d+)/)[0] } @CW;

  # HTML kopf ausgeben
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
EOF

  # Nun die Datenbank Zeile fr Zeile durchsuchen, bis der entsprechende eintrag gefunden wurde ;)
  foreach $line (@CW)
  {
    chomp($line);
    # Als erstes die Zeilen aufsplitten (holy cow :)
    ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
    unless($s_gametype) { $s_gametype = $default_gametype; }
    unless($s_report) { $s_report = 'Kein Bericht vorhanden.'; }
    # Wenn $i_num und $f_num bereinstimmen -> ausgeben d. Tabelle *g*
    if ($i_num == $f_num)
    {
      $s_enclan_safe = "$s_enclan";
      $i_num_safe = $i_num;
      # OK, wir brauchen noch ein paar Daten. 1. Gesamtscore
      ($i_score, $i_scoreen, $i_wins, $i_losses) = getscore($s_maps);
      if ($i_wins > $i_losses) { $ins_ownend = "<font color=\"$style_won\"><b>$i_score</b></font>"; $ins_enend = "<font color=\"$style_lost\"><b>$i_scoreen</b></font>"; }
      elsif ($i_wins < $i_losses) { $ins_ownend = "<font color=\"$style_lost\"><b>$i_score</b></font>"; $ins_enend = "<font color=\"$style_won\"><b>$i_scoreen</b></font>"; }
      else { 
       if ($i_score > $i_scoreen) { $ins_ownend = "<font color=\"$style_won\"><b>$i_score</b></font>"; $ins_enend = "<font color=\"$style_lost\"><b>$i_scoreen</b></font>"; }
       elsif ($i_score < $i_scoreen) { $ins_ownend = "<font color=\"$style_lost\"><b>$i_score</b></font>"; $ins_enend = "<font color=\"$style_won\"><b>$i_scoreen</b></font>"; }
       else { $ins_ownend = "<font color=\"$style_draw\"><b>$i_score</b></font>"; $ins_enend = "<font color=\"$style_draw\"><b>$i_scoreen</b></font>"; }
      }
      # Ausgeben des ganzen mists loool
      print <<EOF;
      <div align="center"><table width="95%" border="1" cellspacing="0" cellpadding="3" bordercolor="$style_border">
       <tr><td colspan="3" bgcolor="$style_table"><b><i>Match Daten f&uuml;r $hash_clansshort{$s_ownclan} vs. $s_enclanshort</i></b></td></tr>
       <tr><td bgcolor="$style_table">Datum:</td><td bgcolor="$style_table2" colspan="2">$style_marked_b$i_day.$i_month.$i_year$style_marked_e</td></tr>
       <tr><td bgcolor="$style_table">Gametype:</td><td bgcolor="$style_table2" colspan="2">$style_marked_b$s_gametype$style_marked_e</td></tr>
       <tr><td bgcolor="$style_table">Matchart:</td><td bgcolor="$style_table2" colspan="2">$style_marked_b$s_type$style_marked_e</td></tr>
       <tr><td bgcolor="$style_table2">&nbsp;</td><td bgcolor="$style_table"><i><b>$s_ownclan</b></i></td><td bgcolor="$style_table"><i><b>$s_enclan</b></i></td></tr>
       <tr><td bgcolor="$style_table">Teilnehmer:</td><td bgcolor="$style_table2">$style_marked_b$s_players$style_marked_e</td><td bgcolor="$style_table2">$style_marked_b$s_enplayers$style_marked_e</td></tr>
EOF
      # OK, hier werden wir die einzelnen Maps aufzhlen. =)
      my @MAPS = split(/;;;/, $s_maps);
      foreach $map (@MAPS) {
       ($s_mapname, $i_caps, $i_encaps, $s_pic) = split (/;;/, $map);
       if ($i_caps > $i_encaps) { $ins_own = "<font color=\"$style_won\">$i_caps</font>"; $ins_en = "<font color=\"$style_lost\">$i_encaps</font>"; }
       elsif ($i_caps < $i_encaps) { $ins_own = "<font color=\"$style_lost\">$i_caps</font>"; $ins_en = "<font color=\"$style_won\">$i_encaps</font>"; }
       else { $ins_own = "$style_marked_b$i_caps$style_marked_e"; $ins_en = "$style_marked_b$i_encaps$style_marked_e"; }
       if (stat("$path_pic/$i_num$s_mapname$s_pic\.jpg")) { $htmlpic = ", <a href=\"$url_script?action=shot&num=$f_num&pic=$url_pic/$i_num$s_mapname$s_pic\.jpg&map=$s_mapname\">Shot</a>"; } else { $htmlpic = ''; }
       print "        <tr><td bgcolor=\"$style_table\" nowrap>$s_mapname$htmlpic:</td><td bgcolor=\"$style_table2\">$ins_own</td><td bgcolor=\"$style_table2\">$ins_en</td></tr>\n";
      }
      print <<EOF;
       <tr><td bgcolor="$style_table"><b>Endscore:</b></td><td bgcolor="$style_table2">$ins_ownend</td><td bgcolor="$style_table2">$ins_enend</td></tr>
       <tr bgcolor="$style_table"><td colspan="3"><b><i>Matchbericht</i></b></td></tr>
       <tr><td colspan="3" bgcolor="$style_table2">$s_report</td></tr>
      </table></div>
EOF
    }
  }

# Verweise auf andere Matches gegen den selben Clan
  print <<EOF;
   <p align="left"><b>Spiele gegen $s_enclan_safe:</b></p>
   <div align="center">
    <table border=1 cellpadding=3 cellspacing=0 width=95% bordercolor="$style_border">
     <tr bgcolor="$style_table"><td><b><i>Datum</i></b></td><td><b><i>Gametype</i></b></td><td><b><i>Score</i></b></td><td><b><i>Matchtype</i></b></td><td><b><i>Options</i></b></td></tr>
EOF

  foreach $line (@CW) {
   ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
   unless($s_gametype) { $s_gametype = $default_gametype; }
   if ($s_enclan_safe eq $s_enclan)
   {
    ($i_score, $i_enscore, $i_wins, $i_losses) = getscore($s_maps);
    if ($i_wins > $i_losses) { $ins_score = "<font color=\"$style_won\"><b>$i_score : $i_enscore</b></font>"; }
    elsif ($i_wins < $i_losses) { $ins_score = "<font color=\"$style_lost\"><b>$i_score : $i_enscore</b></font>"; }
    else { 
     if ($i_score > $i_enscore) { $ins_score = "<font color=\"$style_won\"><b>$i_score : $i_enscore</b></font>"; }
     elsif ($i_score < $i_enscore) { $ins_score = "<font color=\"$style_lost\"><b>$i_score : $i_enscore</b></font>"; }
     else { $ins_score = "<font color=\"$style_draw\"><b>$i_score : $i_enscore</b></font>"; }
    }
    $color = swapcolor($color);
    print <<EOF;
    <tr bgcolor="$color">
     <td>$style_marked_b$i_day.$i_month.$i_year$style_marked_e</td>
     <td>$style_marked_b$s_gametype$style_marked_e</td>
     <td>$style_marked_b$ins_score$style_marked_e</td>
     <td>$style_marked_b$s_type$style_marked_e</td>
     <td>$style_marked_b<a href="$url_script?action=details&num=$i_num">details</a>$style_marked_e</td>
    </tr>
EOF
   }
  }
  
  print <<EOF;
    </table>
   </div>
   
   <p align="center"><b>[ <a href="$url_script?action=view">Zur&uuml;ck zur &Uuml;bersicht</a> ]</b></p>
   $html_foot
EOF
  exit;
}


##############################################################################
#
# stats: Ausgeben der Statistik.
#
##############################################################################
sub add_stat
{
 $size = $_[0];
 $percent = $_[1];
 $title = $_[2];
 push(@arr_size, $size);
 push(@arr_percent, $percent);
 push(@arr_title, $title);
}

sub flush_stats
{
 @arr_size = ();
 @arr_percent = ();
 @arr_title = ();
}

sub offset_stats
{
 $o = 1;
 foreach $entry (@arr_size) { if ($entry > $o) { $o = $entry; } }
 $off = 300 / $o;
 return $off;
}

sub draw_stats_h
{
 $height = $_[1];
 $num = $#arr_size + 1;
 $offset = offset_stats();
 print <<EOF;
 <div align="center">
  <table border=1 cellpadding=3 cellspacing=0 bordercolor="$style_border" width=95%>
   <tr bgcolor="$style_table"><td colspan=2><b><i>$_[0]</i></b></td></tr>
   <tr>
    <td bgcolor="$style_table" align="right" valign="top" width=33%>
     <table border=0 cellpadding=0 cellspacing=2>
EOF
 for ($counter = 0; $counter < $num; $counter++) {
  print <<EOF;
      <tr height="$height"><td nowrap align="right">$arr_title[$counter]:</td></tr>
EOF
 }
 print <<EOF;
     </table>
    </td>
    <td bgcolor="$style_table2" align="left" valign="top" width=67%>
     <table border=0 cellpadding=0 cellspacing=2>
EOF
 for ($counter = 0; $counter < $num; $counter++) {
  $width = $arr_size[$counter] * $offset;
  print <<EOF;
      <tr height="$height"><td nowrap valign="center" align="left"><table border=0 cellpadding=0 cellspacing=0><tr><td><img src="$bar_h" height="$height" width="$width"></td><td>&nbsp;$style_marked_b<font size="1">$arr_percent[$counter]</font>$style_marked_e</td></tr></table></td></tr>
EOF
 }
 print <<EOF;
     </table>
    </td>
   </tr>
  </table>
 </div>
 <br>
EOF
 flush_stats();
}

sub draw_stats_v
{
 $width = $_[1];
 $num = $#arr_size + 1;
 $offset = offset_stats();
 print <<EOF;
 <div align="center">
  <table border=1 cellpadding=3 cellspacing=0 bordercolor="$style_border" width=95%>
   <tr bgcolor="$style_table"><td colspan=2><b><i>$_[0]</i></b></td></tr>
   <tr><td bgcolor="$style_table" rowspan="2" width="10">&nbsp</td><td bgcolor="$style_table2" align="left">
    <table border=0 cellpadding=1 cellspacing=0><tr>
EOF
 for($counter = 0; $counter < $num; $counter++) {
  $height = $arr_size[$counter] * $offset;
  print <<EOF;
     <td valign=bottom>
      <table border=0 cellpadding=0 cellspacing=0>
       <tr><td align="center"><font color="$style_table2" size="1">$arr_title[$counter]</font><br><font size=1>$style_marked_b$arr_percent[$counter]$style_marked_e</font></td></tr>
       <tr><td align="center"><img src="$bar_v" width="$width" height="$height"></td></tr>
      </table>
     </td>
EOF
 }
 print <<EOF;
    </tr></table>
   </td></tr>
   <tr><td bgcolor="$style_table">
    <table border=0 cellpadding=1 cellspacing=0><tr>
EOF
 for($counter = 0; $counter < $num; $counter++) {
  print <<EOF;
     <td valign=top>
      <table border=0 cellpadding=0 cellspacing=0 width="$width">
       <tr><td align="center"><font size="1">$arr_title[$counter]</font></td></tr>
      </table>
     </td>
EOF
 } 
 print <<EOF;
    </tr></table>
   </td></tr>
  </table>
 </div>
EOF
 flush_stats();
}

sub stats
{
 # Define some default staff :D
 unless($f_gametype) { $f_gametype = $array_gametypes[0]; }
 unless($f_ownclan) { @a_keys = keys %hash_clans; $f_ownclan = $a_keys[0]; }
 $f_method = $req->param('method'); unless($f_method) { $f_method = 'Allgemeines'; }
 
 #Generate Combos
 foreach $line (@array_gametypes) {
  if ($line eq $f_gametype) { $sep = ' SELECTED'; } else { $sep = ''; }
  $ins_gametypes = "$ins_gametypes <option value=\"$line\"$sep>$line</option>";
 }
 while (($clan, $www) = each %hash_clans) {
  if ($clan eq $f_ownclan) { $sep = ' SELECTED'; } else { $sep = ''; }
  $ins_clans = "$ins_clans <option value=\"$clan\"$sep>$clan</option>";
 }
 my @METHODS = ('Alles anzeigen', 'Allgemeines', 'Siege / Niederlagen', 'Mapstatistik');
 foreach $line (@METHODS) {
  if ($line eq $f_method) { $sep = ' SELECTED'; } else { $sep = ''; }
  $ins_methods = "$ins_methods <option value=\"$line\"$sep>$line</option>";
 }
 
 # Datenbank auslesen und vorbereiten
 open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW_U = <DB>; close(DB);

 HTTPHead();
 print <<EOF;
 $html_head
 $html_nav
 <div align="center">
  <table border=0 cellpadding=0 cellspacing=0 width=95%><tr>
   <td align="left" valign="center"><h3>$f_ownclan &gt; $f_gametype</h3></td>
   <td align="right" valign="center"><form type=POST action="$url_script" ENCTYPE="multipart/form-data">
    <input type=hidden name="action" value="stats">
    <table border=0 cellpadding=0 cellspacing=0><tr>
     <td><select name="ownclan">$ins_clans</select></td><td>&nbsp;<b>&gt;</b>&nbsp;</td>
     <td><select name="gametype">$ins_gametypes</select></td><td>&nbsp;<b>&gt;</b>&nbsp;</td>
     <td><select name="method">$ins_methods</select></td><td>&nbsp;</td>
     <td><input type="submit" value="Show"></td>
    </tr></table>
    </form>
   </td>
  </tr></table>
 </div>
EOF
 if ($#CW_U < 0) { print "<p align=\"center\"><b>Keine Matches eingetragen - Stats nicht m&ouml;glich.</b></p>\n$html_foot"; exit; }
 
####### Allgemeines ###
 $matches = 0; $ownscore = 0; $enemyscore = 0; $mapsplayed = 0;
 $scorewins = 0; $scorelosses = 0; $scoredraws = 0;
 $mapwins = 0; $maplosses = 0; $mapdraws = 0;
 foreach $line (@CW_U) { chomp($line);
  $s_ownclan = (split '\|\|', $line)[5]; $s_maps = (split '\|\|', $line)[11]; $s_type = (split '\|\|', $line)[12]; $s_gametype = (split '\|\|', $line)[14]; chomp($s_gametype);
  $s_enclan = (split '\|\|', $line)[6]; $s_enclanshort = (split '\|\|', $line)[7];
  unless ($s_gametype) { $s_gametype = $default_gametype; }
  $hash_gametypes{"$s_gametype"} += 1;
  
#  ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
  if (($f_ownclan eq $s_ownclan) && ($f_gametype eq $s_gametype)) {
   ($score, $enscore, $wins, $enwins) = getscore($s_maps);
   my @MAPS = split(/;;;/, $s_maps); $mapsplayed += $#MAPS + 1;
   $matches++; $ownscore += $score; $enemyscore += $enscore;
   if ($score > $enscore) { $scorewins++; }
   elsif ($score < $enscore) { $scorelosses++; }
   else { $scoredraws++; }
   if ($wins > $enwins) { $mapwins++; }
   elsif ($wins < $enwins) { $maplosses++; }
   else { $mapdraws++; }
   $hash_types{"$s_type"} += 1;
   if ($score) { $hash_scorewins{"$s_enclan - <b>$s_enclanshort</b>"} += $score; }
   if ($enscore) { $hash_scorelosses{"$s_enclan - <b>$s_enclanshort</b>"} += $enscore; }
   if ($wins) { $hash_mapwins{"$s_enclan - <b>$s_enclanshort</b>"} += $wins; }
   if ($enwins) { $hash_maplosses{"$s_enclan - <b>$s_enclanshort</b>"} += $enwins; }
   
   foreach $map (@MAPS) {
    ($map_name, $map_caps, $map_encaps, $rest) = split(/;;/, $map);
    $hash_mapmost{"$map_name"} += 1;
    if ($map_caps > $map_encaps) { $hash_mapswon{"$map_name"} += 1; }
    if ($map_caps < $map_encaps) { $hash_mapslost{"$map_name"} += 1; }
   }
  }
 }
 
 if ($matches == 0) {print "<p align=center><b>Keine Clanwars vorhanden. Statistik kann nicht angezeigt werden.</b></p>$html_foot"; exit; }
 $ins_mapspromatch = sprintf("%.2f", $mapsplayed / $matches);
 $ins_scorepromatch = sprintf("%.2f", $ownscore / $matches);
 $ins_enscorepromatch = sprintf("%.2f", $enemyscore / $matches);
 $ins_scorepromap = sprintf("%.2f", $ownscore / $mapsplayed);
 $ins_enscorepromap = sprintf("%.2f", $enemyscore / $mapsplayed);
 if (($f_method eq 'Allgemeines') || ($f_method eq 'Alles anzeigen')) {
  print <<EOF;
 <div align="center">
  <table border=1 cellpadding=3 cellspacing=0 bordercolor="$style_border" width=95%>
   <tr bgcolor="$style_table"><td colspan=4><b><i>Allgemeine Statistik f&uuml;r $f_ownclan</i></b></td></tr>
   <tr>
    <td bgcolor="$style_table" align="right" valign="top" width=25%>
     <table border=0 cellpadding=2 cellspacing=0>
      <tr><td nowrap align="right">Matches gesamt gespielt:</td></tr>
      <tr><td nowrap align="right">Maps gesamt gespielt:</td></tr>
      <tr><td nowrap align="right">Maps pro Match (Durchschnitt):</td></tr>
      <tr><td nowrap align="right">Score gesamt:</td></tr>
      <tr><td nowrap align="right">Gegn. Score gesamt:</td></tr>
     </table>
    </td>
    <td bgcolor="$style_table2" align="left" valign="top" width=25%>
     <table border=0 cellpadding=2 cellspacing=0>
      <tr><td nowrap align="left">$style_marked_b$matches$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$mapsplayed$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$ins_mapspromatch$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$ownscore$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$enemyscore$style_marked_e</td></tr>
     </table>
    </td>
    <td bgcolor="$style_table" align="right" valign="top" width=25%>
     <table border=0 cellpadding=2 cellspacing=0>
      <tr><td nowrap align="right">Score pro Match (Durchschnitt):</td></tr>
      <tr><td nowrap align="right">Gegn. Score pro Match (Durchschnitt):</td></tr>
      <tr><td nowrap align="right">Score pro Map (Durchschnitt):</td></tr>
      <tr><td nowrap align="right">Gegn. Score pro Map (Durchschnitt):</td></tr>
     </table>
    </td>
    <td bgcolor="$style_table2" align="left" valign="top" width=25%>
     <table border=0 cellpadding=2 cellspacing=0>
      <tr><td nowrap align="left">$style_marked_b$ins_scorepromatch$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$ins_enscorepromatch$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$ins_scorepromap$style_marked_e</td></tr>
      <tr><td nowrap align="left">$style_marked_b$ins_enscorepromap$style_marked_e</td></tr>
     </table>
    </td>
   </tr>
  </table>
 </div>
 <br>
EOF

####### Wins / Losses ###
 $ins_perc_scorewins = sprintf("%.0f\%", 100 * $scorewins / $matches); $ins_height_scorewins = (100 * $scorewins / $matches) * 2;
 $ins_perc_scorelosses = sprintf("%.0f\%", 100 * $scorelosses / $matches); $ins_height_scorelosses = (100 * $scorelosses / $matches) * 2;
 $ins_perc_scoredraws = sprintf("%.0f\%", 100 * $scoredraws / $matches); $ins_height_scoredraws = (100 * $scoredraws / $matches) * 2;
 $ins_perc_mapwins = sprintf("%.0f\%", 100 * $mapwins / $matches); $ins_height_mapwins = (100 * $mapwins / $matches) * 2;
 $ins_perc_maplosses = sprintf("%.0f\%", 100 * $maplosses / $matches); $ins_height_maplosses = (100 * $maplosses / $matches) * 2;
 $ins_perc_mapdraws = sprintf("%.0f\%", 100 * $mapdraws / $matches); $ins_height_mapdraws = (100 * $mapdraws / $matches) * 2;
 print <<EOF;
 <div align="center">
  <table border=1 cellpadding=3 cellspacing=0 bordercolor="$style_border" width=95%>
   <tr bgcolor="$style_table"><td width=50%><b><i>Matchergebnisse, nach Score</i></b></td><td width=50%><b><i>Matchergebnisse, nach Mapergebnissen</i></b></td></tr>
   <tr bgcolor="$style_table2">
    <td valign="bottom" align="center"><table border=0 cellpadding=2 cellspacing=0><tr>
     <td valign="bottom" align="center">$style_marked_b<font size="1">$scorewins ($ins_perc_scorewins)</font>$style_marked_e<br><img src="$bar_v" width="50" height="$ins_height_scorewins"><table width=50 border=0 cellpadding=0 cellspacing=0 bgcolor="$style_table"><tr><td align="center"><font size=1>gewonnen</font></td></tr></table></td>
     <td valign="bottom" align="center">$style_marked_b<font size="1">$scorelosses ($ins_perc_scorelosses)</font>$style_marked_e<br><img src="$bar_v" width="50" height="$ins_height_scorelosses"><table width=50 border=0 cellpadding=0 cellspacing=0 bgcolor="$style_table"><tr><td align="center"><font size=1>verloren</font></td></tr></table></td>
     <td valign="bottom" align="center">$style_marked_b<font size="1">$scoredraws ($ins_perc_scoredraws)</font>$style_marked_e<br><img src="$bar_v" width="50" height="$ins_height_scoredraws"><table width=50 border=0 cellpadding=0 cellspacing=0 bgcolor="$style_table"><tr><td align="center"><font size=1>unentsch.</font></td></tr></table></td>
    </tr></table></td>
    <td valign="bottom" align="center"><table border=0 cellpadding=2 cellspacing=0><tr>
     <td valign="bottom" align="center">$style_marked_b<font size="1">$mapwins ($ins_perc_mapwins)</font>$style_marked_e<br><img src="$bar_v" width="50" height="$ins_height_mapwins"><table width=50 border=0 cellpadding=0 cellspacing=0 bgcolor="$style_table"><tr><td align="center"><font size=1>gewonnen</font></td></tr></table></td>
     <td valign="bottom" align="center">$style_marked_b<font size="1">$maplosses ($ins_perc_maplosses)</font>$style_marked_e<br><img src="$bar_v" width="50" height="$ins_height_maplosses"><table width=50 border=0 cellpadding=0 cellspacing=0 bgcolor="$style_table"><tr><td align="center"><font size=1>verloren</font></td></tr></table></td>
     <td valign="bottom" align="center">$style_marked_b<font size="1">$mapdraws ($ins_perc_mapdraws)</font>$style_marked_e<br><img src="$bar_v" width="50" height="$ins_height_mapdraws"><table width=50 border=0 cellpadding=0 cellspacing=0 bgcolor="$style_table"><tr><td align="center"><font size=1>unentsch.</font></td></tr></table></td>
    </tr></table></td>
   </tr>   
   <tr bgcolor="$style_table"><td colspan=2>&nbsp;</td></tr>
  </table>
 </div><br>
EOF

####### Gametypes / Matchtypes ###
 $counter = 0;
 foreach $entry (sort { $hash_types{$b} <=> $hash_types{$a} } keys %hash_types) {
  if ($counter == 0) { $offset = $hash_types{$entry}; }
  $ins_height = 100 * $hash_types{$entry} / $offset;
  add_stat($ins_height, "$hash_types{$entry}", $entry);
  $counter ++;
 }
 draw_stats_h("Gespielte Matchtypes", 20);
# print "\n<hr width=95% noshade><br>\n";
 
 }  else { flush_stats(); }
 
####### Gegn. Clans nach Score ###

 $counter = 0;
 foreach $entry (sort { $hash_scorewins{$b} <=> $hash_scorewins{$a} } keys %hash_scorewins) {
  if ($counter == 0) { $offset = $hash_scorewins{$entry}; }
  $ins_height = 100 * $hash_scorewins{$entry} / $offset;
  add_stat($ins_height, "$hash_scorewins{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Siege / Niederlagen') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Gegn. Clans, sortiert nach dem Score von $f_ownclan", 20);
 } else { flush_stats(); }

####### Gegn. Clans nach Gegn. Score ###

 $counter = 0;
 foreach $entry (sort { $hash_scorelosses{$b} <=> $hash_scorelosses{$a} } keys %hash_scorelosses) {
  if ($counter == 0) { $offset = $hash_scorelosses{$entry}; }
  $ins_height = 100 * $hash_scorelosses{$entry} / $offset;
  add_stat($ins_height, "$hash_scorelosses{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Siege / Niederlagen') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Gegn. Clans, sortiert nach dem Score vom jeweiligen Gegner", 20);
 } else { flush_stats(); }
 
####### Gegn. Clans nach Mapwins ###

 $counter = 0;
 foreach $entry (sort { $hash_mapwins{$b} <=> $hash_mapwins{$a} } keys %hash_mapwins) {
  if ($counter == 0) { $offset = $hash_mapwins{$entry}; }
  $ins_height = 100 * $hash_mapwins{$entry} / $offset;
  add_stat($ins_height, "$hash_mapwins{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Siege / Niederlagen') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Gegn. Clans, sortiert nach der Anzahl Maps, gewonnen von $f_ownclan", 20);
 } else { flush_stats(); }
 
####### Gegn. Clans nach Mapwins vom Gegner ###

 $counter = 0;
 foreach $entry (sort { $hash_maplosses{$b} <=> $hash_maplosses{$a} } keys %hash_maplosses) {
  if ($counter == 0) { $offset = $hash_maplosses{$entry}; }
  $ins_height = 100 * $hash_maplosses{$entry} / $offset;
  add_stat($ins_height, "$hash_maplosses{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Siege / Niederlagen') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Gegn. Clans, sortiert nach der Anzahl Maps, gewonnen vom Gegner", 20);
 } else { flush_stats(); }
 
# print "\n<hr width=95% noshade><br>\n";
 
####### Meist gespielten Maps ###

 $counter = 0;
 foreach $entry (sort { $hash_mapmost{$b} <=> $hash_mapmost{$a} } keys %hash_mapmost) {
  if ($counter == 0) { $offset = $hash_mapmost{$entry}; }
  $ins_height = 100 * $hash_mapmost{$entry} / $offset;
  add_stat($ins_height, "$hash_mapmost{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Mapstatistik') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Meist gespielten Maps", 20);
 } else { flush_stats(); }
 
####### Meist gewonnen Maps ###

 $counter = 0;
 foreach $entry (sort { $hash_mapswon{$b} <=> $hash_mapswon{$a} } keys %hash_mapswon) {
  if ($counter == 0) { $offset = $hash_mapswon{$entry}; }
  $ins_height = 100 * $hash_mapswon{$entry} / $offset;
  add_stat($ins_height, "$hash_mapswon{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Mapstatistik') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Maps, am h&auml;ufigsten gewonnen von $f_ownclan", 20);
 } else { flush_stats(); }
 
####### Meist gewonnene Maps vom Gegner ###

 $counter = 0;
 foreach $entry (sort { $hash_mapslost{$b} <=> $hash_mapslost{$a} } keys %hash_mapslost) {
  if ($counter == 0) { $offset = $hash_mapslost{$entry}; }
  $ins_height = 100 * $hash_mapslost{$entry} / $offset;
  add_stat($ins_height, "$hash_mapslost{$entry}", $entry);
  $counter ++;
}
 if (($f_method eq 'Mapstatistik') || ($f_method eq 'Alles anzeigen')) {
  draw_stats_h("Maps, am h&auml;ufigsten gewonnen vom Gegner", 20);
 } else { flush_stats(); }
 
 print <<EOF;
 $html_foot
EOF
 exit;
}


##############################################################################
#
# add: Anzeigen des Formulars fr das Hinzufgen eines CWs
#
##############################################################################
sub add
{
  login(1);
  # OK, hier wird wohl net viel stehen.
  # 1. Anzeigen des Formulars
  # Hmm, das wars auch schon
  $f_enclanwww = 'http://';
  $f_nummaps = '2';
  $form = genaddform(addmaps);
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <p align="left">$text_add</p>
  <div align="center">
  $form
  </div>
  $html_foot
EOF
  exit;
}


##############################################################################
#
# addmaps: Add the amount of maps specified in $f_nummaps
#
##############################################################################
sub addmaps
{
  login(1);
  # Ersteinmal berprfen, ob wir alles an Parametern haben, also, ob alle Eingaben gemacht wurden!
  unless ($f_date && $f_ownclan && $f_enclan && $f_enclanshort && $f_players && $f_enplayers && $f_nummaps && $f_type) { die error(form); }
  $f_report =~ s/\"/'/g;
  
  # Den unsichtbaren Mist holen ;-)
  $hiddenform = genaddforminvis();
  
  # OK, jetzt INVIS-Formular ausgeben, und dann die Map Tabelle
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <p align="left">$text_addmaps</p>
  <div align="center"><form method=post action="$url_script" ENCTYPE="multipart/form-data">
  <table border="1" cellspacing="0" cellpadding="4" bordercolor="$style_border">
    <tr bgcolor="$style_table"><td><i><b>Nummer</b></i></td><td><i><b>Map-Name</b></i></td><td><i><b>Score $hash_clansshort{$f_ownclan}</b></i></td><td><i><b>Score $f_enclanshort</b></i></td></tr>
EOF
  for ($counter = 1; $counter <= $f_nummaps; $counter++)
    { print "<tr><td bgcolor=\"$style_table\">$counter.</td><td bgcolor=\"$style_table2\"><select name=\"map$counter\">$html_mapscombo</select></td><td bgcolor=\"$style_table2\"><input type=text name=\"caps$counter\" maxlength=3 value=\"0\"></td><td bgcolor=\"$style_table2\"><input type=text name=\"encaps$counter\" maxlength=3 value=\"0\"></td></tr>\n"; }
  print <<EOF;
    </table>
    $hiddenform
    <input type=hidden name="action" value="post">
    <br><input type=submit value="&nbsp;&nbsp;Eintragen&nbsp;&nbsp;" class="form2"> <input type=reset value="Zur&uuml;cksetzen" class="form2"> <input type=button value="&nbsp;&nbsp;&nbsp;Zur&uuml;ck&nbsp;&nbsp;&nbsp;" onClick="javascrript:history.back ()" class="form2">
    </form></div>
EOF

  print "$html_foot"; exit;
}


##############################################################################
#
# post: posten des neuen eintrages
#
##############################################################################
sub post
{
  login(1);
  # Ersteinmal berprfen, ob wir alles an Parametern haben, also, ob alle Eingaben gemacht wurden!
  unless ($f_date && $f_ownclan && $f_enclan && $f_enclanshort && $f_players && $f_enplayers && $f_nummaps && $f_type) { die error(form); }
  $f_report =~ s/\"/'/g; $f_report =~ s/\cM//g; $f_report =~ s/\n/<br>/g; $f_report =~ s/\r//g;
  unless($f_report) { $f_report = 'Kein Bericht vorhanden.'; }
  
  # Zhler erhhen
  $i_num = inccount();
  
  # OKI, also wir werden erstmal die Zeile vorbereiten, die wir schreiben mssen *zitter*
  # Als 1. mal die Maps encodieren ;-)
  for ($counter = 1; $counter <= $f_nummaps; $counter++)
  {
    if ($counter > 1) { $seperator = ';;;'; }
    $m_map = $req->param("map$counter"); $m_caps = $req->param("caps$counter"); $m_encaps = $req->param("encaps$counter");
    # String erstellen
    $s_maps = "$s_maps$seperator$m_map;;$m_caps;;$m_encaps;;$counter";
  }
  # Als 2. das Datum aufsplitten ;-)
  ($i_day, $i_month, $i_year) = split(/\./, $f_date);
  # Berechnen des Datums (encodierung)
  $i_date = ($i_year * 372) + ($i_month * 31) + $i_day;
  
  # OK, nun die Zeile zusammenstellen:
  $s_line = "$i_num\|\|$i_date\|\|$i_year\|\|$i_month\|\|$i_day\|\|$f_ownclan\|\|$f_enclan\|\|$f_enclanshort\|\|$f_enclanwww\|\|$f_players\|\|$f_enplayers\|\|$s_maps\|\|$f_type\|\|$f_report\|\|$f_gametype\n";
  
  # Nun die Datenbank zum appenden ffnen
  open(CW, ">>$path_cw/$file_db"); print CW "$s_line"; close(CW);
  
  redirection("Das Match wird hinzugef&uuml;gt.");
  exit;
}


##############################################################################
#
# del: Lschen eines Eintrags :)
#
##############################################################################
sub del
{
  login(1);
  # OKI, berprfen, ob wir alles an parametern haben :)
  unless ($f_num) { die error(missing_param); }
  
  # OK, die Datenbank auslesen :)
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  
  # Datenbank zum re-writen ffnen
  open(DB, ">$path_cw/$file_db") || die error(no_file_db_write);
  
  foreach $line (@CW)
  {
    ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report) = split(/\|\|/, $line);
    unless ($i_num == $f_num) { chomp($line); print DB "$line\n"; }
  }
  
  # Datenbank schlieen
  close(DB);
  redirection("Der Eintrag $f_num wird aus der Datenbank gel&ouml;scht.");
  exit;
}


##############################################################################
#
# edit: Editieren eines Eintrags
#
##############################################################################
sub edit
{
  # als 1. Login berprfen!
  login(1);
  # OKI, berprfen, ob wir alles an parametern haben :)
  unless ($f_num) { die error(missing_param); }
  
  # OK, die Datenbank auslesen :)
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  
  # So jetzt die Datenbank nach dem anzuzeigenden Eintrag durchsuchen
  foreach $line (@CW)
  {
    chomp ($line);
    ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
    if ($i_num == $f_num)
    {
      # Variablen belegen
      $f_date = "$i_day.$i_month.$i_year";
      $f_ownclan = "$s_ownclan"; $f_enclan = "$s_enclan"; $f_enclanshort = "$s_enclanshort"; $f_enclanwww = "$s_enclanwww";
      $f_players = "$s_players"; $f_enplayers = "$s_enplayers"; $f_type = "$s_type"; $f_report = "$s_report"; $f_gametype = "$s_gametype";
      $f_report =~ s/<br>/\n/g;      
      # OK, ausgeben von der ganzen Gagge...
      $form = genaddform(change);
      HTTPHead();
      print <<EOF;
      $html_head
      $html_nav
      <p align="left">$text_edit</p>
      <div align="center">
      $form
      <br>
      <table border="1" cellspacing="0" cellpadding="4" bordercolor="$style_border">
       <tr bgcolor="$style_table"><td><i><b>Map-Name</b></i></td><td><i><b>Caps $hash_clansshort{$f_ownclan}</b></i></td><td><i><b>Caps $f_enclanshort</b></i></td></tr>
EOF
      # So, jetzt noch die Maps
      my @MAPS = split(/;;;/, $s_maps);
  
      # Nun jede Zeile des Arrays nochmals aufsplitten, und dann die Scores zusammenzhlen ;-)
      for ($counter = 0; $counter <= $#MAPS; $counter++)
      {
       ($mapname, $caps, $encaps, $pic) = split (/;;/, $MAPS[$counter]);
       # Combo neu generieren
       $html_mapscombo = '';
       $counter++;
       foreach $map (@array_maps) { if ($mapname eq $map) { $seperator = ' selected'; } else { $seperator = ''; } $html_mapscombo = "$html_mapscombo    <option value=\"$map\"$seperator>$map</option>\n"; }
       print "<tr><td bgcolor=\"$style_table2\"><select name=\"map$counter\">$html_mapscombo</select></td><td bgcolor=\"$style_table2\"><input type=text name=\"caps$counter\" maxlength=3 value=\"$caps\"></td><td bgcolor=\"$style_table2\"><input type=text name=\"encaps$counter\" maxlength=3 value=\"$encaps\"></td></tr>\n";
       $counter--;
      }
      
      $f_nummaps = $#MAPS + 1;
      
      # Noch den Rest ausgeben ;-)
      print <<EOF;
      </table><br><br><input type=hidden name="num" value="$f_num"><input type=hidden name="nummaps" value="$f_nummaps">
      <input type=submit value="&nbsp;&nbsp;&nbsp;Weiter&nbsp;&nbsp;&nbsp;" class="form2"> <input type=reset value="Zur&uuml;cksetzen" class="form2"></form></div>
      $html_foot
EOF
    }
  }

}


##############################################################################
#
# change: finally change the entry
#
##############################################################################
sub change
{
  login(1);
  # Ersteinmal berprfen, ob wir alles an Parametern haben, also, ob alle Eingaben gemacht wurden!
  unless ($f_num && $f_date && $f_ownclan && $f_enclan && $f_enclanshort && $f_players && $f_enplayers && $f_nummaps && $f_type) { die error(form); }
  $f_report =~ s/\"/'/g; $f_report =~ s/\cM//g; $f_report =~ s/\n/<br>/g; $f_report =~ s/\r//g;
  unless($f_report) { $f_report = 'Kein Bericht vorhanden.'; }
  
  # Als 1. mal die Maps encodieren ;-)
  for ($counter = 1; $counter <= $f_nummaps; $counter++)
  {
    if ($counter > 1) { $seperator = ';;;'; }
    $m_map = $req->param("map$counter"); $m_caps = $req->param("caps$counter"); $m_encaps = $req->param("encaps$counter");
    $s_maps = "$s_maps$seperator$m_map;;$m_caps;;$m_encaps;;$counter";
  }
  
  # Als 2. das Datum aufsplitten ;-)
  ($i_day, $i_month, $i_year) = split(/\./, $f_date);
  # Berechnen des Datums (encodierung)
  $i_date = ($i_year * 372) + ($i_month * 31) + $i_day;
  
  # OK, nun aktuelle DB auslesen
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  open(DB, ">$path_cw/$file_db") || die error(no_file_db_write);
  
  foreach $line (@CW)
  {
    ($i_num, $rest) = split(/\|\|/, $line);
    if ($i_num == $f_num)
    {
     print DB "$i_num\|\|$i_date\|\|$i_year\|\|$i_month\|\|$i_day\|\|$f_ownclan\|\|$f_enclan\|\|$f_enclanshort\|\|$f_enclanwww\|\|$f_players\|\|$f_enplayers\|\|$s_maps\|\|$f_type\|\|$f_report\|\|$f_gametype\n";
    } else { chomp($line); print DB "$line\n"; }
  }
  
  close(DB);
  
  # Schluss
  redirection("Der Eintrag $f_num wurde editiert.");
  exit;
}


##############################################################################
#
# pix: Hochladen von pix fr ein bestimmten eintrag :)
#
##############################################################################
sub pix
{
  login(1);
  # Parameter berprfen ;-)
  unless ($f_num) { die error(missing_param); }
  # OK, als erstes DB auslesen :)
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  
  # Nun die Datenbank Zeile fr Zeile durchsuchen, bis der entsprechende eintrag gefunden wurde ;)
  foreach $line (@CW)
  {
    # Als erstes die Zeilen aufsplitten (holy cow :)
    ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report) = split(/\|\|/, $line);
    # Wenn $i_num und $f_num bereinstimmen -> ausgeben d. Tabelle *g*
    if ($i_num == $f_num) { @MAPS = split(/;;;/, $s_maps); }
  }
  
  $form =<<EOF;
  <table border=1 cellspacing=0 cellpadding=4 bordercolor="$style_border">
   <tr nowrap><td bgcolor="$style_table"><b><i>Mapname:</i></b></td bgcolor="$style_table"><td bgcolor="$style_table"><b><i>Dateiname:</i></b></td><td bgcolor="$style_table"><b><i>Lokale Datei:</i></b></td><td bgcolor="$style_table"><b><i>Optionen:</i></b></td></tr>
EOF

  $counter = 1;
  foreach $map (@MAPS) {
    ($s_mapname, $i_caps, $i_encaps, $s_pic) = split (/;;/, $map);
    if (stat("$path_pic/$i_num$s_mapname$s_pic\.jpg")) { $m_filename = "$i_num$s_mapname$s_pic.jpg"; } else { $m_filename = '<i>none</i>'; }
    $form =<<EOF;
$form
     <form method=POST action="$url_script" ENCTYPE="multipart/form-data"><tr><td bgcolor="$style_table2">$style_marked_b$s_mapname$style_marked_e</td><td bgcolor="$style_table2">$style_marked_b$m_filename$style_marked_e</td><td bgcolor="$style_table2">$style_marked_b<input type=file name="$s_mapname">$style_marked_e</td><td bgcolor="$style_table2">$style_marked_b<input type=submit value="Upload / Delete" class="form2">$style_marked_e</td></tr>
     <input type="hidden" name="action" value="pixup"><input type=hidden name="num" value="$f_num"><input type=hidden name="map" value="$s_mapname"><input type=hidden name="nummaps" value="$counter"></form>
EOF
  $counter++;
  }

  $form =<<EOF;
$form
  </table>
EOF
  # HTML ausgeben
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <p align="left">$text_upload</p>
  <div align="center">
  $form
  </div>
  $html_foot
EOF
  exit;
}


##############################################################################
#
# pixup: Hochladen von Bildern & Abndern in der jeweiligen Datei
#
##############################################################################
sub pixup
{
  # Parameter berprfen ;-)
#  $f_num = $req->param('num'); # Zahl des CW Eintrags
#  $f_map = $req->param('map'); # Mapname
#  $f_nummaps = $req->param('nummaps'); # Mapindex
  $f_locfile = $req->param("$f_map"); # Datei
  unless ($f_num && $f_map && $f_nummaps) { die error(missing_param); }
  
  # Serverdateinamen generieren
  $s_serfile = "$path_pic/$f_num$f_map$f_nummaps\.jpg";
  
  # Entweder Datei hochladen, oder Lschen!
  if ($f_locfile) {
    # Datei ffnen
    open(OUTFILE, ">$s_serfile");
    # Datei hochladen *g*
    while (my $i_bytes = read($f_locfile, my $buffer, 1024)) { print OUTFILE $buffer; }  
    # Datei schlieen
    close(OUTFILE);
  } else {
    unlink($s_serfile); # Datei Lschen *g*
  }
#  print "Location:$url_script\n\n";
  if ($f_locfile) { redirection("Die Datei $f_num$f_map$f_nummaps\.jpg wurde hochgeladen"); }
  else { redirection("Der Screenshot wurde entfernt."); }
  exit;
}


##############################################################################
#
# shot: Anzeigen eines Screenshots *g*
#
##############################################################################
sub shot
{
  # URL ermitteln
  $f_pic = $req->param('pic');
  
  # berprfen, ob alles an params da ist *g*
  unless ($f_map && $f_pic && $f_num) { die error(missing_param); }
    
  # Site ausgeben *g*
  HTTPHead();
  print <<EOF;
   $html_head
   $html_nav
   <div align="center"><table border=1 cellpadding=4 cellspacing=0 bordercolor="$style_border">
     <tr><td bgcolor="$style_table"><b><i>Screenshot von $f_map</i></b></td></tr>
     <tr><td bgcolor="$style_table2"><img src="$f_pic"></td></tr>
   </table></div>
   <p align="center"><b>[ <a href="$url_script?action=details&num=$f_num">Zur&uuml;ck</a> ]</b></p>
   $html_foot
EOF
  exit;
}


##############################################################################
##############################################################################

##############################################################################
#
# actions: Anzeigen von Next Actions
#
##############################################################################
sub actions
{
 autodel();
 
 @clans_keys = keys %hash_clans;
 unless ($f_num) { $f_num = @clans_keys[0]; }
 unless ($f_gametype) { $f_gametype = 'All'; }
 
 # 1. Datenbank auslesen!
 open(DB, "<$path_cw/$file_next") || die error(no_file_next); @NEXT = <DB>; close(DB);
 open(DB, "<$path_cw/$file_fdb") || die error(no_file_fdb); @FDB = <DB>; close(DB);
 @NEXT = sort { ($a =~ /\|(\d+)/)[0] <=> ($b =~ /\|(\d+)/)[0] } @NEXT; # sortieren
 
 while (($clan, $www) = each %hash_clans) { 
  if ($f_num eq $clan) { $seperator = ' selected'; } else { $seperator = ''; } 
  $ins_clans = "$ins_clans <option value=\"$clan\" $seperator>$clan</option>\n"; 
 }
 $ins_gametypes = "<option value=\"All\">Show all Types</option>";
 foreach $gametype (@array_gametypes) { 
  if ($f_gametype eq $gametype) { $seperator = ' selected'; } else { $seperator = ''; } 
  $ins_gametypes = "$ins_gametypes <option value=\"$gametype\" $seperator>$gametype</option>\n"; 
 }
 
 
 # HTML Kopf & Formular zur Clanwahl drucken
 HTTPHead();
 print <<EOF;
 $html_head
 $html_nav
 <div align="center">
  <table border=0 cellpadding=0 cellspacing=0 width=95%>
   <tr>
    <td align=left><h3>$f_num &gt; $f_gametype:</h3></td>
    <td align=right><form type=POST action="$url_script" ENCTYPE="multipart/form-data">
     <table border=0 cellpadding=0 cellspacing=0><tr>
      <td><select name="num">$ins_clans</select></td>
      <td><b>&nbsp;&gt;&nbsp;</b></td>
      <td><select name="gametype">$ins_gametypes</select></td>
      <td>&nbsp;<input type=submit value="Show"></td>
     </tr></table><input type=hidden name="action" value="actions"></form>
    </td>
   </tr>
  </table>
  </div>
 <div align="center">
EOF

 foreach $line (@NEXT)
 {
  # OK, erstmal splitten *puh*
  chomp($line);
  ($i_num, $i_date, $s_date, $i_time_b, $i_time_e, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_kontakt, $s_kontakt_email, $s_kontakt_icq, $s_server, $s_server_ip, $s_maps, $i_players, $s_mutators, $i_timelimit, $i_caplimit, $s_color, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
  
  unless ($s_gametype) { $s_gametype = $array_gametypes[0]; }
  if (($f_num eq $s_ownclan) && (($s_gametype eq $f_gametype) || ($f_gametype eq 'All'))) {
   print <<EOF;
    <table border="1" width="95%" cellspacing="0" cellpadding="4" bordercolor="$style_border">
     <tr><td colspan="4" bgcolor="$style_table"><b><i>$s_type $hash_clansshort{$s_ownclan} vs. $s_enclanshort</i></b></td></tr>
     <tr><td bgcolor="$style_table">Datum:</td><td bgcolor="$style_table2"><b>$style_marked_b$s_date$style_marked_e</b></td>
         <td bgcolor="$style_table">Uhrzeit:</td><td bgcolor="$style_table2"><b>$style_marked_b$i_time_b - $i_time_e$style_marked_e</b></td></tr>
     <tr><td bgcolor="$style_table">Clan:</td><td bgcolor="$style_table2">$style_marked_b<a href="$hash_clans{$s_ownclan}" target="_blank">$s_ownclan</a>$style_marked_e</td>
         <td bgcolor="$style_table">Gegner:</td><td bgcolor="$style_table2">$style_marked_b<a href="$s_enclanwww" target="_blank">$s_enclan</a>$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">Gametype:</td><td bgcolor="$style_table2">$style_marked_b$s_gametype$style_marked_e</td>
         <td bgcolor="$style_table">Matchtype:</td><td bgcolor="$style_table2">$style_marked_b$s_type$style_marked_e</td></tr>         
     <tr><td bgcolor="$style_table">Kontakt:</td><td bgcolor="$style_table2">$style_marked_b<a href="mailto:$s_kontakt_email">$s_kontakt</a>$style_marked_e</td>
         <td bgcolor="$style_table">Kontakt ICQ:</td><td bgcolor="$style_table2">$style_marked_b<a href="http://wwp.mirabilis.com/scripts/Search.dll?to=$s_kontakt_icq">$s_kontakt_icq</a>$style_marked_e</td></tr>         
     <tr><td bgcolor="$style_table">Server:</td><td bgcolor="$style_table2">$style_marked_b$s_server$style_marked_e</td>
         <td bgcolor="$style_table">Server IP:</td><td bgcolor="$style_table2">$style_marked_b<a href="unreal://$s_server_ip" target="_blank">$s_server_ip</a>$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">Players:</td><td bgcolor="$style_table2">$style_marked_b$i_players on $i_players$style_marked_e</td>
         <td bgcolor="$style_table">Farbe $hash_clansshort{$s_ownclan}:</td><td bgcolor="$style_table2">$style_marked_b$s_color$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">Score Limit:</td><td bgcolor="$style_table2">$style_marked_b$i_caplimit$style_marked_e</td>
         <td bgcolor="$style_table">Timelimit:</td><td bgcolor="$style_table2">$style_marked_b$i_timelimit$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">Maps:</td><td bgcolor="$style_table2">$style_marked_b$s_maps$style_marked_e</td>
         <td bgcolor="$style_table">Mutators:</td><td bgcolor="$style_table2">$style_marked_b$s_mutators$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">Kommentar:</td><td colspan="3" bgcolor="$style_table2">$style_marked_b$s_report$style_marked_e</td></tr>
     <tr><td colspan="4" bgcolor="$style_table"><b><i>Angemeldete Spieler:</i></b></td></tr>
EOF
   
   # Spieler hinzufuegen
   foreach $fdb_line (@FDB) {
    # Splitten
    chomp($fdb_line);
    ($i_fdbnum, $s_name, $s_email, $s_comment) = split(/\|\|/, $fdb_line);
    if ($i_fdbnum == $i_num) {
     print "     <tr><td bgcolor=\"$style_table\"><a href=\"mailto:$s_email\">$s_name</a></td><td colspan=\"3\" bgcolor=\"$style_table2\">$style_marked_b$s_comment$style_marked_e</td></tr>\n";
    }
   }

   print <<EOF;  
     <tr><td bgcolor="$style_table"><b><i>Optionen:</i></b></td><td colspan="3" bgcolor="$style_table2">$style_marked_b<a href="$url_script?action=addfeedback&num=$i_num">Anmelden</a>, <a href="$url_script?action=delfeedback&num=$i_num">Abmelden</a>&nbsp;&nbsp;<font style="1"><a href="$url_script?action=actionsedit&num=$i_num">edit</a>, <a href="$url_script?action=actionsdel&num=$i_num">delete</a></font>$style_marked_e</td></tr>
    </table><br><br>
EOF
  } 
 }

 # Fuss ausgeben & Proggi beenden
 print <<EOF;
 </div>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# actionsadd: Hinzufuegen von Next Actions
#
##############################################################################
sub actionsadd
{
  login(1);
  # Vordefinieren der Variablen
  $f_enclanwww = 'http://';
  $f_server = "$default_server";
  $f_server_ip = "$default_server_ip";
  $f_players = '5';
  $form = genactionsform('actionspost');
  
  # Einfach nur ein HTML Formular anzeigen, wo die ganze gagge eingegen werden kann
  HTTPHead();
  print <<EOF;
  $html_head
  $html_nav
  <p align="left">$text_actionsadd</p>
  <div align="center">
  $form
  </div>
  $html_foot
EOF
}


##############################################################################
#
# actionspost: Schlussendliches abschicken & hinzufuegen der Daten
#
##############################################################################
sub actionspost
{
  login(1);
  # OKi, fehlende Params durch '----' ersetzen
  unless ($f_ownclan && $f_date && $f_time_b) { die error('form'); }
  $f_report =~ s/\"/'/g;
  unless ($f_time_e) { $f_time_e = '--:--'; }
  unless ($f_enclan) { $f_enclan = '----'; } unless ($f_enclanwww) { $f_enclanwww = '----'; } unless ($f_enclanshort) { $f_enclanshort = '----'; }
  unless ($f_kontakt) { $f_kontakt = '----'; } unless ($f_kontakt_email) { $f_kontakt_email = '----'; } unless ($f_kontakt_icq) { $f_kontakt_icq = '----'; }
  unless ($f_server) { $f_server = '----'; } unless ($f_server_ip) { $f_server_ip = '----'; } unless ($f_maps) { $f_maps = '----'; }
  unless ($f_players) { $f_players = '----'; } unless ($f_mutators) { $f_mutators = '----'; } unless ($f_timelimit) { $f_timelimit = '----'; }
  unless ($f_caplimit) { $f_caplimit = '----'; } unless ($f_color) { $f_color = '----'; } unless ($f_type) { $f_type = 'Match'; }
  unless ($f_report) { $f_report = '&nbsp;'; }
  
  # Oki, Zaehler erhoehen
  $i_num = inccount();
  
  # Datumsangabe generieren
  ($day, $month, $year) = split(/\./, $f_date);
  ($min, $hour) = split(/\:/, $f_time_b);
  $i_date = $day + ($month * 31) + ($year * 372);
  
  # Zeile vorbereiten.
  $line = "$i_num\|\|$i_date\|\|$f_date\|\|$f_time_b\|\|$f_time_e\|\|$f_ownclan\|\|$f_enclan\|\|$f_enclanshort\|\|$f_enclanwww\|\|$f_kontakt\|\|$f_kontakt_email\|\|$f_kontakt_icq\|\|$f_server\|\|$f_server_ip\|\|$f_maps\|\|$f_players\|\|$f_mutators\|\|$f_timelimit\|\|$f_caplimit\|\|$f_color\|\|$f_type\|\|$f_report\|\|$f_gametype\n";
  # Die DB zum appenden oeffnen
  open(DB, ">>$path_cw/$file_next") || die error(no_file_next); print DB "$line"; close(DB);
  
  redirection("Der Eintrag wurde hinzugef&uuml;gt.", 'actions');
  exit;
}


##############################################################################
#
# actionsdel: Lschen von Next Actions
#
##############################################################################
sub actionsdel
{
  login(1);
  # Params ueberpruefen
  unless ($f_num) { die error(missing_param); }
  
  # Datenbank auslesen
  open(DB, "<$path_cw/$file_next") || die error(no_file_next); @NEXT = <DB>; close(DB);
  
  # Datenbank zum Zurueckschreiben oeffnen
  open(DB, ">$path_cw/$file_next") || die error(no_file_next);
  
  # Zeilen durchsuchen
  foreach $line (@NEXT)
  {
  	chomp ($line);
    # Zeile aufsplitten
    ($i_num, $i_date, $s_date, $i_time_b, $i_time_e, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_kontakt, $s_kontakt_email, $s_kontakt_icq, $s_server, $s_server_ip, $s_maps, $i_players, $s_mutators, $i_timelimit, $i_caplimit, $s_color, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
    unless ($i_num == $f_num) { print DB "$line\n"; }
  }  
  close(DB);

  redirection("Der Eintrag $f_num wurde gel&ouml;scht", 'actions');
  exit;
}


##############################################################################
#
# actionsedit
#
##############################################################################
sub actionsedit
{
 login(1);
 # Params ueberpruefen
 unless($f_num) { die error(missing_param); }
 
 # Datenbank auslesen
 open(DB, "<$path_cw/$file_next") || die error(no_file_next); @NEXT = <DB>; close(DB);
 
 # Zeilen durchsuchen
 foreach $line (@NEXT)
 {
  chomp ($line);
  # Zeile aufsplitten
  ($i_num, $i_date, $f_date, $f_time_b, $f_time_e, $f_ownclan, $f_enclan, $f_enclanshort, $f_enclanwww, $f_kontakt, $f_kontakt_email, $f_kontakt_icq, $f_server, $f_server_ip, $f_maps, $f_players, $f_mutators, $f_timelimit, $f_caplimit, $f_color, $f_type, $f_report, $f_gametype) = split(/\|\|/, $line);
  if ($i_num == $f_num)
  {
    $form = genactionsform('actionschange');
    HTTPHead();
    print <<EOF;
    $html_head
    $html_nav
    <p align="left">$text_actionsedit</p>
    <div align="center">
    $form
    </div>
    $html_foot
EOF
    exit;
  }
 }
 
 exit;
}


##############################################################################
#
# actionschange: Change some Actions :)
#
##############################################################################
sub actionschange
{
  login(1);
  # OKi, fehlende Params durch '----' ersetzen
  unless ($f_num && $f_ownclan && $f_date && $f_time_b) { die error('form'); }
  $f_report =~ s/\"/'/g;
  unless ($f_time_e) { $f_time_e = '--:--'; }
  unless ($f_enclan) { $f_enclan = '----'; } unless ($f_enclanwww) { $f_enclanwww = '----'; } unless ($f_enclanshort) { $f_enclanshort = '----'; }
  unless ($f_kontakt) { $f_kontakt = '----'; } unless ($f_kontakt_email) { $f_kontakt_email = '----'; } unless ($f_kontakt_icq) { $f_kontakt_icq = '----'; }
  unless ($f_server) { $f_server = '----'; } unless ($f_server_ip) { $f_server_ip = '----'; } unless ($f_maps) { $f_maps = '----'; }
  unless ($f_players) { $f_players = '----'; } unless ($f_mutators) { $f_mutators = '----'; } unless ($f_timelimit) { $f_timelimit = '----'; }
  unless ($f_caplimit) { $f_caplimit = '----'; } unless ($f_color) { $f_color = '----'; } unless ($f_type) { $f_type = 'Match'; }
  unless ($f_report) { $f_report = '&nbsp;'; }  
  
  # Datenbank auslesen
  open(DB, "<$path_cw/$file_next") || die error(no_file_next); @NEXT = <DB>; close(DB);
  
  # Datumsangabe generieren
  ($day, $month, $year) = split(/\./, $f_date);
  ($min, $hour) = split(/\:/, $f_time_b);
  $i_date = $day + ($month * 31) + ($year * 372);
  
  # Zeile vorbereiten.
  $linech = "$f_num\|\|$i_date\|\|$f_date\|\|$f_time_b\|\|$f_time_e\|\|$f_ownclan\|\|$f_enclan\|\|$f_enclanshort\|\|$f_enclanwww\|\|$f_kontakt\|\|$f_kontakt_email\|\|$f_kontakt_icq\|\|$f_server\|\|$f_server_ip\|\|$f_maps\|\|$f_players\|\|$f_mutators\|\|$f_timelimit\|\|$f_caplimit\|\|$f_color\|\|$f_type\|\|$f_report\|\|$f_gametype\n";
  
  # Datenbank zum Zurueckschreiben oeffnen
  open(DB, ">$path_cw/$file_next") || die error(no_file_next);
  # Zeilen durchsuchen
  foreach $line (@NEXT)
  {
  	chomp ($line);
    # Zeile aufsplitten
    ($i_num, $i_date, $s_date, $i_time_b, $i_time_e, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_kontakt, $s_kontakt_email, $s_kontakt_icq, $s_server, $s_server_ip, $s_maps, $i_players, $s_mutators, $i_timelimit, $i_caplimit, $s_color, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
    unless ($i_num == $f_num) { print DB "$line\n"; }
    else { print DB "$linech"; }
  }  
  close(DB);

  redirection("Der Eintrag $f_num wurde ge&auml;ndert", 'actions');
  exit;
}


##############################################################################
#
# addfeedback: Anmelden zu einem Clanwar
#
##############################################################################
sub addfeedback
{
 login();
 # Params ueberpruefen
 unless ($f_num) { die error(missing_param); }
 if (checkfeedback("$f_num", "$f_login")) { die error(already_in, $f_login); }
 # HTML formular anzeigen
 HTTPHead();
 print <<EOF;
 $html_head
 $html_nav
 <p align="left">$text_feedback</p>
 <div align="center">
  <form method=POST action="$url_script" ENCTYPE="multipart/form-data">
   <input type="hidden" name="login" value="$f_login">
   <input type="hidden" name="passwd" value="$f_passwd">
   <input type="hidden" name="num" value="$f_num">
   <input type="hidden" name="action" value="postfeedback">
    <table border="1" cellspacing="0" cellpadding="4" bordercolor="$style_border">
     <tr><td bgcolor="$style_table"><b><i>Beschreibung</i></b></td><td bgcolor="$style_table"><b><i>Option</i></b></td></tr>
     <tr><td bgcolor="$style_table">Name:</td><td bgcolor="$style_table2">$style_marked_b$f_login$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">eMail:</td><td bgcolor="$style_table2">$style_marked_b$f_email$style_marked_e</td></tr>
     <tr><td bgcolor="$style_table">Kurzer Kommentar (Optional):</td><td bgcolor="$style_table2"><input type=text name="report" size="30" class="form1"></td></tr>
    </table><br>
    <input type=submit value="&nbsp;&nbsp;Weiter&nbsp;&nbsp;" class="form2">&nbsp;<input type=reset value="&nbsp;Zur&uuml;cksetzen" class="form2">
  </form>
 </div>
 $html_foot
EOF
 exit;
}


##############################################################################
#
# postfeedback: Feedback Posten...
#
##############################################################################
sub postfeedback
{
 login();
 # Params ueberpruefen
 unless ($f_num) { die error(missing_param); }
 unless ($f_report) { $f_report = '&nbsp;'; }
 
 # Zeile vorbereiten
 $line = "$f_num\|\|$f_login\|\|$f_email\|\|$f_report\n";
 
 # Feedback zum appenden oeffnen
 open (DB, ">>$path_cw/$file_fdb") || die error(no_file_fdb); print DB "$line"; close(DB);
 
 # Beenden
 redirection("Spieler $f_login erfolgreich angemeldet", 'actions');
 exit;
}


##############################################################################
#
# delfeedback: Feedback lschen (Abmelden)
#
##############################################################################
sub delfeedback
{
 login();
 # Params ueberpruefen
 unless ($f_num) { die error(missing_param); }
 if (!checkfeedback("$f_num", "$f_login")) { die error(not_in, $f_login); }
 
 # Feedback oeffnen
 open (DB, "<$path_cw/$file_fdb") || die error(no_file_fdb); @FDB = <DB>; close(DB);
 
 # Feedback zum zurueckschreiben oeffnen
 open (DB, ">$path_cw/$file_fdb") || die error(no_file_fdb);
 foreach $line (@FDB)
 {
  chomp($line);
  ($i_num, $s_name, $s_email, $s_comment) = split(/\|\|/, $line);
  unless ($i_num == $f_num && $f_login eq $s_name) { print DB "$line\n"; }
 }
 close(DB);
 
 redirection("Spieler $f_login erfolgreich abgemeldet", 'actions'); 
 exit;
}


##############################################################################
##############################################################################
##############################################################################


##############################################################################
#
# init: Initializierung des Skriptes (Auslesen der DB, usw...) ;-)
#
##############################################################################
sub init
{  
  # Als erstes mal die DB auslesen ...
  # Die Datenbank kann nun unter @CW angesteuert werden
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW = <DB>; close(DB);
  
  # Dann zhlen wir mal die Anzahl der Eintrge, und speichern sie in $i_CW_num
  $i_CW_num = $#CW;

  # Enumerate the amount of "own" clans ;-)
  while (($clanname, $clanwww) = each %hash_clans) {$i_clans_num++;}
  
  # HTML Map Combo generieren
  foreach $map (@array_maps) { $html_mapscombo = "$html_mapscombo    <option value=\"$map\"$seperator>$map</option>\n"; }
  # OKI, das solls auch schon gewesen sein ;-)
}


##############################################################################
#
# getscore: ermittelt die score im format (eigene, gegn)
#
##############################################################################
sub getscore
{
  # OK, wir BRAUCHEN einen parameter
  $maps = $_[0]; $score = 0; $enscore = 0; $wins = 0; $losses = 0;
  
  # Aufsplitten, und in ein Array machen...
  my @MAPS = split(/;;;/, $maps);
  
  # Nun jede Zeile des Arrays nochmals aufsplitten, und dann die Scores zusammenzhlen ;-)
  foreach $map (@MAPS)
  {
    ($mapname, $caps, $encaps, $pic) = split (/;;/, $map);
    $score += $caps; $enscore += $encaps;
    if ($caps > $encaps) { $wins++; }
    if ($caps < $encaps) { $losses++; }
  }
  
  return ($score, $enscore, $wins, $losses);
}


##############################################################################
#
# inccount: Erhhen der Zhlvariable, und zurckliefern des neuen Wertes
#
##############################################################################
sub inccount
{
  # OKI, als 1. Counterdatei ffnen & auslesen
  open(CNT, "<$path_cw/$file_cnt") || die error(no_file_cnt); $i_count = <CNT>; close(CNT);
  # Erhhen des Counters
  $i_count++;
  # Zurckschreiben des Counters
  open(CNT, ">$path_cw/$file_cnt") || die error(no_file_cnt); print CNT "$i_count"; close(CNT);
  # Zurckgeben des neuen Counterstandes
  return ($i_count);
}


##############################################################################
#
# checkfeedback: berprfen ob ein User schon angemeldet ist oder nicht
#
##############################################################################
sub checkfeedback
{
 open(DB, "<$path_cw/$file_fdb") || die error(no_file_fdb); @FDB = <DB>; close(DB);
 foreach $line (@FDB)
 {
  chomp($line);
  ($i_num, $s_name, $s_email, $s_comment) = split(/\|\|/, $line);
  if ($i_num == $_[0] && $s_name eq $_[1]) { return(1); }
 }
 
 return(0);
}


##############################################################################
#
# genquickstats: quick statistik generieren
# 
##############################################################################
sub genquickstats
{
 my $clan = $_[0];
 my $gametype = $_[1];
 my $matches = 0;
 my $wongames = 0;
 my $lostgames = 0;
 my $drawgames = 0;
 my $ownscore = 0;
 my $enescore = 0;
 open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @STATS = <DB>; close(DB);
 foreach $entry (@STATS) { chomp($entry);
  ($db_num, $db_date, $db_year, $db_month, $db_day, $db_ownclan, $db_enclan, $db_enclanshort, $db_enclanwww, $db_players, $db_enplayers, $db_maps, $db_type, $db_report, $db_gametype) = split(/\|\|/, $entry);
  unless($db_gametype) { $db_gametype = "$default_gametype"; }
  
  if ( (($db_gametype eq $gametype) || ($gametype eq 'All')) && ($db_ownclan eq $clan) ) {
   $matches++;
   ($score, $enscore, $wins, $losses) = getscore($db_maps);
   if ($wins > $losses) { $wongames++; }
   elsif ($wins < $losses) { $lostgames++; }
   else { if ($score > $enscore) { $wongames++; } elsif ($score < $enscore) { $lostgames++; } else { $drawgames++; } }
   $ownscore += $score;
   $enescore += $enscore;
  }
 }
 
 print <<EOF;
 <div align="center">
  <table border=0 cellpadding=0 cellspacing=0 width=95%><tr>
  <td>
   <b>Quick Stats:</b>
   Gesamt: $style_marked_b$matches$style_marked_e |
   Gewonnen: $style_marked_b$wongames$style_marked_e |
   Verloren: $style_marked_b$lostgames$style_marked_e |
   Unentschieden: $style_marked_b$drawgames$style_marked_e |
   Score: $style_marked_b$ownscore$style_marked_e |
   Gegn. Score: $style_marked_b$enescore$style_marked_e
  </td>
  </tr></table>
 </div>
EOF
}


##############################################################################
#
# genaddform: Generieren des "Hinzufgen - Formulars" von <form> bis </form>
# onChange="forms[0].TableStripTextColor.value=options[selectedIndex].value"
##############################################################################
sub genaddform
{
  $ins_enclans = '<option value="" short="" www="http://">-- existing clans --</option>';
  $last = '';
  open(DB, "<$path_cw/$file_db") || die error(no_file_db_read); my @CW_U = <DB>; close(DB);
  @CW = sort { (split '\|\|', $a)[6] cmp (split '\|\|', $b)[6] } @CW_U;
  foreach $line (@CW) { chomp($line);
   $a_enclan = (split '\|\|', $line)[6];
   $a_enclanshort = (split '\|\|', $line)[7];
   $a_enclanwww = (split '\|\|', $line)[8];
#   ($i_num, $i_date, $i_year, $i_month, $i_day, $s_ownclan, $s_enclan, $s_enclanshort, $s_enclanwww, $s_players, $s_enplayers, $s_maps, $s_type, $s_report, $s_gametype) = split(/\|\|/, $line);
   unless($last eq $a_enclan) { 
    $hash_playedclans{"$a_enclan"} = "$a_enclanshort"; 
    $ins_enclans = "$ins_enclans <option value=\"$a_enclan\" short=\"$a_enclanshort\" www=\"$a_enclanwww\">$a_enclan</option>"; 
   }
   $last = $a_enclan;
  }
  
  unless ($f_date) { 
   $time_day = (localtime time)[3]; if (length($time_day) == 1) { $time_day = "0$time_day"; }
   $time_mon = (localtime time)[4] + 1; if (length($time_mon) == 1) { $time_mon = "0$time_mon"; }
   $time_year = (localtime time)[5] + 1900;
   $f_date = "$time_day.$time_mon.$time_year";
  }
  
  # OK, wird net schwer, also erstmal alles ausgeben bis zur 1. Combo (NEIN, nicht ASMD Combo ;-)
  $addform =<<EOF;
  <form method=POST action="$url_script" ENCTYPE="multipart/form-data">
  <input type=hidden name="login" value="$f_login">
  <input type=hidden name="passwd" value="$f_passwd">
  <table border="1" cellspacing="0" cellpadding="4" bordercolor="$style_border">
    <tr bgcolor="$style_table"><td><i><b>Beschreibung</b></i></td><td><i><b>Option</b></i></td></tr>
    <tr><td bgcolor="$style_table">Datum (Maske: tt.mm.jjjj):</td><td bgcolor="$style_table2"><input type="text" name="date" class="form1" value="$f_date"></td></tr>
    <tr><td bgcolor="$style_table">Eigener Clan:</td><td bgcolor="$style_table2"><select name="ownclan">
EOF
  # Hier die eigenen Clans generieren
  while (($ownclan, $ownclanwww) = each %hash_clans) { 
    if ($ownclan eq $f_ownclan) { $seperator = ' selected'; } else { $seperator = ''; }
    $addform = "$addform    <option value=\"$ownclan\"$seperator>$ownclan</option>\n"; 
  }
  $addform =<<EOF;
$addform
     </select></td></tr>
    <tr><td bgcolor="$style_table">Gegnerischer Clan (Vorauswahl):</td><td bgcolor="$style_table2"><select name="selector" onChange="num=selectedIndex; forms[0].enclan.value=options[num].value; forms[0].enclanshort.value=options[num].short; forms[0].enclanwww.value=options[num].www;">$ins_enclans</select></td></tr>
    <tr><td bgcolor="$style_table">Gegnerischer Clan (Voller Name):</td><td bgcolor="$style_table2"><input type="text" name="enclan" class="form1" value="$f_enclan"></td></tr>
    <tr><td bgcolor="$style_table">Gegnerischer Clan K&uuml;rzel:</td><td bgcolor="$style_table2"><input type="text" name="enclanshort" class="form1" value="$f_enclanshort"></td></tr>
    <tr><td bgcolor="$style_table">Gegnerischer Clan Website (inkl. http://):</td><td bgcolor="$style_table2"><input type="text" name="enclanwww" class="form1" value="$f_enclanwww"></td></tr>
    <tr><td bgcolor="$style_table">Spieler des eigenen Clans:</td><td bgcolor="$style_table2"><input type="text" name="players" class="form1" value="$f_players"></td></tr>
    <tr><td bgcolor="$style_table">Spieler des gegnerischen Clans:</td><td bgcolor="$style_table2"><input type="text" name="enplayers" class="form1" value="$f_enplayers"></td></tr>
EOF
    unless ($_[0] eq 'change') { $addform = "$addform    <tr><td bgcolor=\"$style_table\">Anzahl gespielter Maps:</td><td bgcolor=\"$style_table2\"><input type=\"text\" name=\"nummaps\" class=\"form1\" value=\"$f_nummaps\"></td></tr>"; }
  $addform = <<EOF;
$addform
    <tr><td bgcolor="$style_table">Gametype:</td><td bgcolor="$style_table2"><select name="gametype">
EOF

  # Hier die Game typen eintragen
  foreach $type (@array_gametypes) {
    if ($type eq $f_gametype) { $seperator = ' selected'; } else { $seperator = ''; }
    $addform = "$addform     <option value=\"$type\"$seperator>$type</option>\n";
  }
  
  $addform = <<EOF;
$addform  
    <tr><td bgcolor="$style_table">Matchtype:</td><td bgcolor="$style_table2"><select name="type">
EOF
  # Hier die Match typen eintragen
  foreach $type (@array_types) {
    if ($type eq $f_type) { $seperator = ' selected'; } else { $seperator = ''; }
    $addform = "$addform     <option value=\"$type\"$seperator>$type</option>\n";
  }
  $addform =<<EOF;
$addform
     </select></td></tr>
  </table><br><table border="1" cellspacing="0" cellpadding="4" bordercolor="$style_border">
    <tr bgcolor="$style_table"><td colspan="2"><b><i>Matchbericht</i></b></td></tr>
    <tr><td width="5%" bgcolor="$style_table">&nbsp;</td><td width="95%" bgcolor="$style_table2"><textarea name="report" cols="75" rows="10" class="form1">$f_report</textarea></td></tr>
  </table><input type=hidden name="action" value="$_[0]"><br>
EOF
    unless ($_[0] eq 'change') { $addform = "$addform  <input type=submit value=\"&nbsp;&nbsp;&nbsp;Weiter&nbsp;&nbsp;&nbsp;\" class=\"form2\"> <input type=reset value=\"Zur&uuml;cksetzen\" class=\"form2\"></form>"; }

  return ($addform); # hihi
}


##############################################################################
#
# genactionsform: Generieren des "Hinzufgen - Formulars" von <form> bis </form>
#
##############################################################################
sub genactionsform
{
  foreach $entry (@array_gametypes) {
   if ($entry eq $f_gametype) { $seperator = ' SELECTED'; } else { $seperator = ''; }
   $ins_gametypes = "$ins_gametypes<option value=\"$entry\"$seperator>$entry</option>";
  }
  
  foreach $entry (@array_types) {
   if ($entry eq $f_type) { $seperator = ' SELECTED'; } else { $seperator = ''; }
   $ins_types = "$ins_types<option value=\"$entry\"$seperator>$entry</option>";
  }

  # Also, das ist net so doll ;-)
  $addform =<<EOF;
    <form method=POST action="$url_script" ENCTYPE="multipart/form-data">
    <input type=hidden name="login" value="$f_login">
    <input type=hidden name="passwd" value="$f_passwd">
    <input type=hidden name="action" value="$_[0]">
    <input type=hidden name="num" value="$f_num">
    <table border="1" cellspacing="0" cellpadding="4" bordercolor="$style_border">
     <tr><td bgcolor="$style_table"><b><i>Beschreibung</i></b></td><td bgcolor="$style_table"><b><i>Option</i></b></td>
         <td bgcolor="$style_table"><b><i>Beschreibung</i></b></td><td bgcolor="$style_table"><b><i>Option</i></b></td></tr>
     
     <tr><td bgcolor="$style_table">Clan*:</td><td bgcolor="$style_table2"><select name="ownclan">
EOF

  # Hier die eigenen Clans generieren
  while (($ownclan, $ownclanwww) = each %hash_clans) { 
    if ($ownclan eq $f_ownclan) { $seperator = ' selected'; } else { $seperator = ''; }
    $addform = "$addform   <option value=\"$ownclan\"$seperator>$ownclan</option>\n"; 
  }
  
  $addform =<<EOF;
$addform</select></td>
         <td bgcolor="$style_table">Datum*:</td><td bgcolor="$style_table2"><input type=text name="date" value="$f_date" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Uhrzeit (Beginn)*:</td><td bgcolor="$style_table2"><input type=text name="time_b" value="$f_time_b" class="form1"></td>
         <td bgcolor="$style_table">Uhrzeit (Ende):</td><td bgcolor="$style_table2"><input type=text name="time_e" value="$f_time_e" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Gametype*:</td><td bgcolor="$style_table2"><select name="gametype">$ins_gametypes</select></td>
         <td bgcolor="$style_table">Matchtype*:</td><td bgcolor="$style_table2"><select name="type">$ins_types</select></td></tr>
     <tr><td bgcolor="$style_table">Gegner Voller Name:</td><td bgcolor="$style_table2"><input type=text name="enclan" value="$f_enclan" class="form1"></td>
         <td bgcolor="$style_table">Gegner K&uuml;rzel:</td><td bgcolor="$style_table2"><input type=text name="enclanshort" value="$f_enclanshort" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Gegner Website:</td><td bgcolor="$style_table2"><input type=text name="enclanwww" value="$f_enclanwww" class="form1"></td>
         <td bgcolor="$style_table">Kontakt Name:</td><td bgcolor="$style_table2"><input type=text name="kontakt" value="$f_kontakt" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Kontakt ICQ:</td><td bgcolor="$style_table2"><input type=text name="kontakt_icq" value="$f_kontakt_icq" class="form1"></td>
         <td bgcolor="$style_table">Kontakt eMail:</td><td bgcolor="$style_table2"><input type=text name="kontakt_email" value="$f_kontakt_email" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Server (Name):</td><td bgcolor="$style_table2"><input type=text name="server" value="$f_server" class="form1"></td>
         <td bgcolor="$style_table">Server IP:</td><td bgcolor="$style_table2"><input type=text name="server_ip" value="$f_server_ip" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Player pro Team:</td><td bgcolor="$style_table2"><input type=text name="players" value="$f_players" class="form1"></td>
         <td bgcolor="$style_table">Farbe (Eigener Clan):</td><td bgcolor="$style_table2"><input type=text name="color" value="$f_color" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Score Limit:</td><td bgcolor="$style_table2"><input type=text name="caplimit" value="$f_caplimit" class="form1"></td>
         <td bgcolor="$style_table">Timelimit:</td><td bgcolor="$style_table2"><input tpye=text name="timelimit" value="$f_timelimit" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Maps:</td><td bgcolor="$style_table2"><input type=text name="maps" value="$f_maps" class="form1"></td>
         <td bgcolor="$style_table">Mutators:</td><td bgcolor="$style_table2"><input type=text name="mutators" value="$f_mutators" class="form1"></td></tr>
     <tr><td bgcolor="$style_table">Kurzer Kommentar:</td><td colspan="3" bgcolor="$style_table2"><input type=text size="60" name="report" value="$f_report" class="form1"></td></tr>
    </table><br>
    <table border=0 cellspacing=0 cellpadding=4>
      <tr><td><input type=submit value="&nbsp;&nbsp;&nbsp;Weiter&nbsp;&nbsp;&nbsp;" class="form2"></td>
      <td><input type=reset value="&nbsp;Zur&uuml;cksetzen&nbsp;" class="form2"></td></tr>
    </table>
    </form>
EOF

 return ($addform); # ooooooooh yeah
}


##############################################################################
#
# genaddforminvis: Generieren des "Hinzufgen - Formulars" von <form> bis </form>
#
##############################################################################
sub genaddforminvis
{
  # So, dies ist nur schreiben von HTML in eine Variable! ;-)
  $addform =<<EOF;
  <input type=hidden name="date" value="$f_date">
  <input type=hidden name="ownclan" value="$f_ownclan">
  <input type=hidden name="enclan" value="$f_enclan">
  <input type=hidden name="enclanshort" value="$f_enclanshort">
  <input type=hidden name="enclanwww" value="$f_enclanwww">
  <input type=hidden name="players" value="$f_players">
  <input type=hidden name="enplayers" value="$f_enplayers">
  <input type=hidden name="nummaps" value="$f_nummaps">
  <input type=hidden name="type" value="$f_type">
  <input type=hidden name="report" value="$f_report">
  <input type=hidden name="login" value="$f_login">
  <input type=hidden name="passwd" value="$f_passwd">
  <input type=hidden name="gametype" value="$f_gametype">
EOF
  return ($addform); # hihi
}


##############################################################################
#
# redirection: Weiterleitungsseite ausgeben
#
##############################################################################
sub redirection
{
  $param = $_[1];
  unless ($param) {$param = 'view'};
  # Dies ist nur HTML zeugs
  HTTPHead();
  print <<EOF;
  $html_head
  <meta http-equiv="refresh" content="3; URL=$url_script?action=$param">
  $html_body
  <div align="center"><font size=4><b>$_[0]</b></font><br>
  <b>Bitte auf Weiterleitung warten.</b></div>
  $html_foot
EOF
}


##############################################################################
#
# error: Fehlerausgabe routine
#
##############################################################################
sub error
{
  # 1. Parameter speichern
  $error = $_[0];
  
  # Je nach Fehler, andere Fehlerbeschreibung generieren
  if ($error eq 'no_file_db_read') { $err_content = "Die Datenbankdatei '$file_db' konnte nicht zum Lesen ge&ouml;ffnet werden."; }
  elsif ($error eq 'no_file_db_write') { $err_content = "Die Datenbankdatei '$file_db' konnte nicht zum Schreiben ge&ouml;ffnet werden. M&ouml;gl. ist der chmod falsch."; }
  elsif ($error eq 'no_file_pwd') { $err_content = "Die Passwortdatei konnte nicht ge&ouml;ffnet werden. M&ouml;glicherweise ist der chmod falsch."; }
  elsif ($error eq 'no_file_next') { $err_content = "Die Next Actions Datenbank '$file_next' konnte nicht ge&ouml;ffnet werden. M&ouml;glicherweise ist der chmod falsch."; }  
  elsif ($error eq 'no_file_fdb') { $err_content = "Die Anmelde-Datenbank '$file_fdb' konnte nicht ge&ouml;ffnet werden. M&ouml;glicherweise ist der chmod falsch."; }  
  elsif ($error eq 'missing_param') { $err_content = "Es wurden nicht gen&uuml;gend Parameter dem Skript &uuml;bergeben. M&ouml;glicherweise liegt ein Skriptfehler vor. Bitte <a href=\"mailto:webmaster\@mvclan.de\">Urheber</a> kontakten!"; }
  elsif ($error eq 'form') { $err_content = "Es wurden nicht alle Felder in dem vorherigen Formular ausgef&uuml;llt. Bitte den 'Zur&uuml;ck'-Button des Browsers dr&uuml;cken, um zur Eingabe zur&uuml;ckzukehren."; }
  elsif ($error eq 'wrong_login') { $err_content = "Die Kombination von Benutzername und Kennwort war ung&uuml;ltig. Der Webmaster wurde informiert."; }
  elsif ($error eq 'already_in') { $err_content = "Der Benutzer $_[1] ist schon angemeldet. Doppelte Anmeldung ist nicht m&ouml;glich. <a href=\"$url_script?action=actions\">Hier</a> klicken, um zur&uuml;ckzukehren."; }
  elsif ($error eq 'not_in') { $err_content = "Der Benutzer $_[1] war nicht angemeldet. Es ist nicht m&ouml;glich sich abzumelden, ohne sich vorher anzumelden. <a href=\"$url_script?action=actions\">Hier</a> klicken, um zur&uuml;ckzukehren."; }
  elsif ($error eq 'perm_denied') { $err_content = "<b>Permission Denied:</b> Der Benutzer $_[1] hat nicht die Berechtigung die gew&uuml;schte Operation durchzuf&uuml;hren."; }
  else { $err_content = "Es ist ein unbekannter Fehler aufgetreten. Die Ausf&uuml;hrung des Skriptes wurde angehalten."; }
  # HTML ausgeben
  HTTPHead();
  print <<EOF;
  $html_head
  $html_body
  <h1>Fehler</h1>
  <div align="left">
    Bei der Ausf&uuml;hrung von <i>$url_script</i> ist ein Fehler aufgetreten.
     <blockquote><h4>$err_content</h4></blockquote>
    <h2>Bitte konsultieren Sie den <a href="mailto:$email_admin">Webmaster</a> der Site, oder den <a href="mailto:webmaster\@mvclan.de">Urheber</a> des Skriptes, und informieren Sie ihn mit der genauen Fehlermeldung.</h2>
  </div>
  $html_foot
EOF
  exit;
}


##############################################################################
#
# autodel: Automatisches lschen von Next Actions ;-)
#
##############################################################################
sub autodel
{
 if ($i_autodel == 0) { return; }
 # Datum generieren.
 ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time); $time_year += 1900; $time_wday += 1; $time_mon += 1;
 $g_date = $time_mday + ($time_mon * 31) + ($time_year * 372);
 # 1. Datenbank auslesen!
 open(DB, "<$path_cw/$file_next") || die error(no_file_next); @NEXT = <DB>; close(DB);
 # Datenbank zum Zurueckschreiben oeffnen
 open(DB, ">$path_cw/$file_next") || die error(no_file_next);
 
 foreach $line (@NEXT)
 {
  # OK, erstmal splitten *puh*
  chomp($line);
  ($i_num, $i_date, $rest) = split(/\|\|/, $line);
  if ($i_date >= $g_date) { print DB "$line\n"; }
 }
 
 close(DB);
 return;
}


##############################################################################
#
# login: Einloggen, bzw. berprfen von pwd / loginname
#
##############################################################################
sub login
{
  $logintype = $_[0];
  unless ($logintype) { $logintype = 0; }
  # OK, erstmal checken, ob wir schon eingeloggt sind
  unless ($f_login && $f_passwd)
  {
    if ($f_num ne '') { $htmlnum = "<input type=hidden name=\"num\" value=\"$f_num\">"; } else { $htmlnum = ''; }
    # OK, hier einfach ein formular ausgeben
    HTTPHead();
    print <<EOF;
    $html_head
    $html_body
    <h1>Member Login</h1>
    <div align="center"><form method=POST action="$url_script" ENCTYPE="multipart/form-data">
    <br>
    <table border="1" cellspacing="0" cellpadding="3" bordercolor="$style_border">
     <tr><td bgcolor="$style_table"><b><i>Username:</i></b></td><td bgcolor="$style_table2"><input type=text name="login" value="$f_login_ck" class="form1"></td></tr>
     <tr><td bgcolor="$style_table"><b><i>Passwort:</i></b></td><td bgcolor="$style_table2"><input type=password name="passwd" value="$f_passwd_ck" class="form1"></td></tr>
     <tr><td bgcolor="$style_table2" colspan="2"><div align="center"><input type=submit value="&nbsp;Einloggen&nbsp;" class="form2"> <input type=reset value="Zur&uuml;cksetzen" class="form2"></div></td></tr>
    </table>
    <input type=hidden name="action" value="$action">
    $htmlnum
    </form></div><br>
    $html_foot
EOF
    exit;
  }
  
  # Passwortdatei auslesen
  open (PWD, "<$path_cw/$file_pwd") || die error(no_file_pwd); my @a_passwd = <PWD>; close(PWD);
  
  foreach $passwdline (@a_passwd) {  
    chomp($passwdline); ($s_login, $s_passwd, $b_crypt, $f_email, $f_admin) = split(/:/, $passwdline);
    $s_salt = substr($f_login, 0, 2); # Schlssel definieren ;)
    if ($b_crypt == 1) {$s_testpwd = crypt($f_passwd, $s_salt);} else {$s_testpwd = $f_passwd;}
    if (($s_testpwd eq $s_passwd) && ($f_login eq $s_login)) { 
    if ($logintype == 1 && $f_admin == 0) { die error(perm_denied, $f_login); }
    $i_setpasscook = 1;
    return } # berprfung der PWDs & Benutzernamen
  }
  
  # Fehler spucken, wenn das Login falsch ist
  # Aber vorher ne eMail senden *g* ;-)
  ($time_sec,$time_min,$time_hour,$time_mday,$time_mon,$time_year,$time_wday,$time_yday,$time_isdst) = localtime(time); $time_year += 1900; $time_wday += 1; $time_mon += 1;
  open (SENDMAIL, "| $path_sendmail -t");
  print SENDMAIL "To: Webmaster <$email_admin>\n";
  print SENDMAIL "From: $path_script <$email_admin>\n";
  print SENDMAIL "Subject: Falsche Passworteingabe\n\n";
  print SENDMAIL <<EOF;
Warnung:
Fuer den Adminbereich des Clanwarskriptes wurde eine falsche Login / Passwort - Kombination eingegeben:

Username: $f_login
Passwort: $f_passwd
IP: $ENV{'REMOTE_ADDR'}
Browser: $ENV{'HTTP_USER_AGENT'}
Datum: $time_mday.$time_mon.$time_year, $time_hour:$time_min.$time_sec

Sollten solche Vorfaelle oefters vorkommen, so ist eine haeufigere Aenderung von Benutzername / Kennwort empfohlen.
Fuer weitere Fragen kontakten Sie bitte [MV]DarkViper.
--------------------------------
Clanwars - Skript by: [MV]DarkViper
eMail: webmaster\@mvclan.de
Webpage: www.mvclan.de
EOF
  close (SENDMAIL);
  die error(wrong_login);
}


##############################################################################
#
# get_input: Retrieve the Parameters! This is sucky complicated :(
#
##############################################################################
sub get_input
{
  $action = $req->param('action');
  $f_num = $req->param('num');
  $f_nummaps = $req->param('nummaps');
  
  $f_login = $req->param('login');
  $f_passwd = $req->param('passwd');
  
  $f_date = $req->param('date');
  $f_ownclan = $req->param('ownclan');
  $f_enclan = $req->param('enclan');
  $f_enclanshort = $req->param('enclanshort');
  $f_enclanwww = $req->param('enclanwww');
  $f_players = $req->param('players');
  $f_enplayers = $req->param('enplayers');
  $f_type = $req->param('type');
  $f_report = $req->param('report');
  $f_map = $req->param('map');
  
  $f_time_b = $req->param('time_b');
  $f_time_e = $req->param('time_e');
  $f_kontakt = $req->param('kontakt');
  $f_kontakt_email = $req->param('kontakt_email');
  $f_kontakt_icq = $req->param('kontakt_icq');
  $f_server = $req->param('server');
  $f_server_ip = $req->param('server_ip');
  $f_maps = $req->param('maps');
  $f_mutators = $req->param('mutators');
  $f_timelimit = $req->param('timelimit');
  $f_caplimit = $req->param('caplimit');
  $f_color = $req->param('color');
  $f_gametype = $req->param('gametype');
  
  $i_setpasscook = 0;
  $f_login_ck = $req->cookie('CK_LOGIN');
  $f_passwd_ck = $req->cookie('CK_PASSWD'); 
  
  # Titel anpassen
  if ($action eq 'stats') { $html_nav =~ s/\%title\%/\/ Statistiken/g; }
  elsif ($action eq 'details') { $html_nav =~ s/\%title\%/\/ Details/g; }
  elsif ($action eq 'view' || !$action) { $html_nav =~ s/\%title\%/\/ Hauptseite/g; }
  elsif ($action eq 'add') { $html_nav =~ s/\%title\%/\/ Hinzuf&uuml;gen/g; }
  elsif ($action eq 'addmaps') { $html_nav =~ s/\%title\%/\/ Maps Hinzuf&uuml;gen/g; }
  elsif ($action eq 'edit') { $html_nav =~ s/\%title\%/\/ Editieren/g; }
  elsif ($action eq 'shot') { $html_nav =~ s/\%title\%/\/ Screenshot/g; }
  elsif ($action eq 'actions') { $html_nav =~ s/\%title\%/\/ Next Actions/g; }
  elsif ($action eq 'actionsadd') { $html_nav =~ s/\%title\%/\/ Hinzuf&uuml;gen/g; }
  elsif ($action eq 'actionsedit') { $html_nav =~ s/\%title\%/\/ Editieren/g; }
  elsif ($action eq 'addfeedback') { $html_nav =~ s/\%title\%/\/ Anmelden/g; }
  else { $html_nav =~ s/\%title\%//g; }
}


##############################################################################
#
# HTTPHead: Einfgen login/passwd in HREFs im Navigationskopf
#
##############################################################################
sub HTTPHead()
{
  
	if ($i_setpasscook){
	        $f_login_ck = $req->cookie(-name=>'CK_LOGIN',
	                                   -value=>$f_login,
	                                   -expires=>"+1y",
	                                   -path=>"/cgi-bin",
	                                   -domain=>"$ENV{'HTTP_HOST'}");
	        $f_passwd_ck = $req->cookie(-name=>'CK_PASSWD',
	                                    -value=>$f_passwd,
	                                    -expires=>"+1y",
	                                    -path=>"/cgi-bin",
	                                    -domain=>"$ENV{'HTTP_HOST'}");
	 print "Content-type: text/html\n";
	 print $req->header(-cookie=>[$f_login_ck,$f_passwd_ck]);
	}
	else{
	       print "Content-type: text/html\n\n";}
}



### swapcolor: swaps the color
sub swapcolor
{
 $input = $_[0];
 if ($input eq $style_table2) { $output = $style_table4; } else { $output = $style_table2; }
 return ($output);
}
